// DigitalIO.cpp : ̨Ӧóڵ㡣
//

#include "stdafx.h"
#include <Windows.h>
#include "YKCat2.h"

static int exit_cmd = 0;

#pragma   comment(lib,   "YKCat2.lib") 
static void print(RetCode result)
{
	if (RET_OK == result)
		return;

	printf("%d\r\n", result);
}

//ȴ˶
static void WaitDone(UINT32 axisIndex)
{
	YKM_GroupStatus status;
	RetCode result;
	while (!exit_cmd)
	{
		result = YKM_GetGroupStatus(axisIndex, &status);
		print(result);
		if (status.Done)
			return;
		Sleep(1);
	}
}

//ȴϵ
static void WaitInit(UINT32 groupIndex)
{
	YKM_GroupStatus status;
	RetCode result;
	while (!exit_cmd)
	{
		result = YKM_GetGroupStatus(groupIndex, &status);
		print(result);
		if (status.Inited)
			return;
		Sleep(1);
	}
}

static void GroupTask()
{
	RetCode result;
	YKM_BusInfo busInfo;

	//ȴϵͳʼ
	while (!exit_cmd)
	{
		result = YKM_GetBusInfo(&busInfo);
		if (busInfo.running)
			break;
		Sleep(100);
	}

	UINT32 groupIndex = 0;

	YKM_GroupProfile profile;
	profile.max_velocity = 500;
	profile.start_velocity = 1;
	profile.stop_dec_emg = 10000;
	profile.stop_dec_smooth = 1000;
	profile.stop_dec_jerk = 10000;
	YKM_SetGroupProfile(groupIndex, profile);
	
	YKM_GroupConfig config;
	config.System = YKM_COORDINATE_ACS;
	config.axisNum = 2;
	config.axisIndex0 = 0;
	config.axisIndex1 = 1;
	YKM_InitGroup(groupIndex, config);
	WaitInit(groupIndex);

	YKM_MoveLinearAbsoluteConfig absConfig;
	absConfig.position.x = 1000;
	absConfig.position.y = 500;
	absConfig.position.z = 0;
	absConfig.velocity = 100;
	absConfig.acceleration = 1000;
	absConfig.decelerateion = 1000;
	absConfig.jerk = 5000;
	absConfig.bufferMode = YKM_BLENDING_LOW;
	absConfig.transMode = YKM_CORNER_DISTANCE;
	absConfig.transPara.x = 1.0;
	absConfig.transPara.y = 0;
	absConfig.transPara.z = 0;
	//256ɱ˶
	YKM_MoveLinearAbsolute(groupIndex, absConfig);

	YKM_MoveLinearRelativeConfig relConfig;
	relConfig.distance.x = 100;
	relConfig.distance.y = 500;
	relConfig.distance.z = 0;
	relConfig.velocity = 100;
	relConfig.acceleration = 1000;
	relConfig.decelerateion = 1000;
	relConfig.jerk = 5000;
	relConfig.bufferMode = YKM_BLENDING_LOW;
	relConfig.transMode = YKM_CORNER_DISTANCE;
	relConfig.transPara.x = 1.0;
	relConfig.transPara.y = 0;
	relConfig.transPara.z = 0;	
	YKM_MoveLinearRelative(groupIndex, relConfig);

	WaitDone(groupIndex);

	double position0 = 0;
	double position1 = 0;
	YKM_ReadCommandPosition(config.axisIndex0, &position0);
	YKM_ReadCommandPosition(config.axisIndex1, &position1);
	printf("position0: %.3f position1: %.3f\r\n", position0, position1);
}

int main()
{
	RetCode result;
	int version = 0;

	result = YKM_GetVersion(&version);
	print(result);

	result = YKM_LoadLib();
	print(result);

	YKM_SysConfig config;
	result = YKM_GetSysConfig(&config);
	printf("input num: %d byte, output num: %d byte, axis num: %d\r\n",
		config.config_input_size, config.config_output_size, config.config_axis_num);

	DWORD dwThreadId = 0;
	CreateThread(NULL, (SIZE_T)NULL, (LPTHREAD_START_ROUTINE)GroupTask, NULL, 0, &dwThreadId);

	while (1)
	{
		getchar();
		exit_cmd = 1;
		break;
	}
	return 0;
}

