// DigitalIO.cpp : ̨Ӧóڵ㡣
//

#include "stdafx.h"
#include <Windows.h>
#include "YKCat2.h"

static int exit_cmd = 0;

#pragma   comment(lib,   "YKCat2.lib") 
static void print(RetCode result)
{
	if (RET_OK == result)
		return;

	printf("%d\r\n", result);
}

//ȴ˶
static void WaitDone(UINT32 axisIndex)
{
	YKM_AxisStatus status;
	RetCode result;
	while (!exit_cmd)
	{
		result = YKM_ReadAxisInfo(axisIndex, &status);
		print(result);
		if (status.Done)
			return;
		Sleep(1);
	}
}

//ȴڲ̽
static void WaitActive(UINT32 axisIndex)
{
	YKM_AxisStatus status;
	RetCode result;
	while (!exit_cmd)
	{
		result = YKM_ReadAxisInfo(axisIndex, &status);
		print(result);
		if (0 == status.Active)
			return;
		Sleep(1);
	}
}

static void AxisTask()
{
	RetCode result;
	YKM_BusInfo busInfo;

	//ȴϵͳʼ
	while (!exit_cmd)
	{
		result = YKM_GetBusInfo(&busInfo);
		if (busInfo.running)
			break;
		Sleep(100);
	}

	UINT32 axisIndex = 0;
	YKM_MoveAbsoluteConfig absConfig;
	absConfig.position = 1000.123;
	absConfig.velocity = 1000;
	absConfig.acceleration = 1000;
	absConfig.decelerateion = 1000;
	absConfig.jerk = 10000;

	YKM_MoveVelocityConfig velConfig;
	velConfig.direction = YKM_DIRECTION_POSITIVE;
	velConfig.velocity = 1000;
	velConfig.acceleration = 1000;
	velConfig.decelerateion = 1000;
	velConfig.jerk = 10000;

	double position = 0;

	while (!exit_cmd)
	{
		//˶
		
		result = YKM_MoveAbsolute(axisIndex, absConfig);
		print(result);
		WaitDone(axisIndex);

		//Թ滮λ
		YKM_ReadCommandPosition(axisIndex, &position);
		printf("%.3f\r\n", position);
		Sleep(500);
		
		//ٶ˶
		result = YKM_MoveVelocity(axisIndex, velConfig);
		print(result);
		Sleep(1000);
		//ֹͣ
		result = YKM_StopAxis(axisIndex, 0);
		print(result);
		WaitActive(axisIndex);

		YKM_ReadCommandPosition(axisIndex, &position);
		printf("%.3f\r\n", position);

		Sleep(500);
	}
}

int main()
{
	RetCode result;
	int version = 0;

	result = YKM_GetVersion(&version);
	print(result);

	result = YKM_LoadLib();
	print(result);

	YKM_SysConfig config;
	result = YKM_GetSysConfig(&config);
	printf("input num: %d byte, output num: %d byte, axis num: %d\r\n",
		config.config_input_size, config.config_output_size, config.config_axis_num);

	DWORD dwThreadId = 0;
	CreateThread(NULL, (SIZE_T)NULL, (LPTHREAD_START_ROUTINE)AxisTask, NULL, 0, &dwThreadId);

	while (1)
	{
		getchar();
		exit_cmd = 1;
		break;
	}
	return 0;
}

