// DigitalIO.cpp : ̨Ӧóڵ㡣
//

#include "stdafx.h"
#include <Windows.h>
#include "YKCat2.h"

#pragma   comment(lib,   "YKCat2.lib") 
static void print(RetCode result)
{
	if (RET_OK == result)
		return;

	printf("%d\r\n", result);
}

static int exit_cmd = 0;

//ȴ˶
static void WaitDone(UINT32 axisIndex)
{
	YKM_AxisStatus status;
	RetCode result;
	while (!exit_cmd)
	{
		result = YKM_ReadAxisInfo(axisIndex, &status);
		print(result);
		if (status.Done)
			return;
		Sleep(1);
	}
}

static void HomeTask()
{
	//ȴϵͳʼ
	while (!exit_cmd)
	{
		YKM_BusInfo busInfo;
		RetCode result = YKM_GetBusInfo(&busInfo);
		if (busInfo.running)
			break;
		Sleep(100);
	}

	UINT32 axisIndex = 0;

	YKM_HomeConfig homeConfig;
	homeConfig.mode = HOME_MODE_01;
	homeConfig.velHigh = 100;
	homeConfig.velLow = 10;
	homeConfig.acceleration = 1000;
	homeConfig.switchMove = 5000;
	homeConfig.probelMove = 5000;
	homeConfig.offset = 0;

	YKM_StartHome(axisIndex, homeConfig);
	WaitDone(axisIndex);

	double position = 0;
	YKM_ReadCommandPosition(axisIndex, &position);
	printf("%.3f\r\n", position);
}

int main()
{
	RetCode result;
	int version = 0;

	result = YKM_GetVersion(&version);
	print(result);

	result = YKM_LoadLib();
	print(result);

	YKM_SysConfig config;
	result = YKM_GetSysConfig(&config);
	printf("input num: %d byte, output num: %d byte, axis num: %d\r\n",
		config.config_input_size, config.config_output_size, config.config_axis_num);

	DWORD dwThreadId = 0;
	CreateThread(NULL, (SIZE_T)NULL, (LPTHREAD_START_ROUTINE)HomeTask, NULL, 0, &dwThreadId);

	while (1)
	{
		getchar();
		exit_cmd = 1;
		break;
	}
	return 0;
}