﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using YKCat2;
using System.Threading;

namespace DigitalIO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        UInt32 axis_num = 0;

        private void buttonLoad_Click(object sender, EventArgs e)
        {
            RetCode result;
            //初始化函数，所有函数使用前必须要先初始化一次
            result = ProCon.YKM_LoadLib();
            if (result != RetCode.RET_OK)
            {
                MessageBox.Show("加载出错" + result.ToString());
                return;
            }

            buttonLoad.Enabled = false;
            buttonLoad.BackColor = Color.Green;

            //或者总线配置信息
            YKM_SysConfig config = new YKM_SysConfig();
            ProCon.YKM_GetSysConfig(out config);
            axis_num = config.config_axis_num;

            comboBoxAxisSel.Items.Clear();
            for (int idx = 0; idx < axis_num; idx++)
            {
                comboBoxAxisSel.Items.Add(idx.ToString());
            }
            comboBoxAxisSel.SelectedIndex = 0;

            timer1.Interval = 100;
            timer1.Enabled = true;
        }

        void currentPos()
        {
            UInt32 axis = 0;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;
            double pos;
            ProCon.YKM_ReadActualPosition(axis, out pos);
            current.Text = pos.ToString("F3");
        }

        Boolean inc_cmd = false;
        int inc_phase = 0;

        void goPosInc()
        {
            if (!inc_cmd)
                return;

            UInt32 axis = 0;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;
            YKM_AxisStatus sta;

            if (0 == inc_phase)
            {                                             
                //判断轴是否在忙中，忙的时候不可以调用别的运动指令                
                ProCon.YKM_ReadAxisInfo(axis, out sta);
                if (0 != sta.Active)
                    return;

                YKM_MoveRelativeConfig axis_inc = new YKM_MoveRelativeConfig();
                axis_inc.distance = (double)pos.Value;
                axis_inc.acceleration = (double)acc.Value;
                axis_inc.decelerateion = (double)acc.Value * 10;
                axis_inc.jerk = 10000;
                axis_inc.velocity = (double)val.Value;

                ProCon.YKM_MoveRelative(axis, axis_inc);
                inc_phase = 1;
                return;
            }

            //判断完成信号
            ProCon.YKM_ReadAxisInfo(axis, out sta);
            if (0 != sta.Done)
                return;

            inc_cmd = false;
        }

        void sysStatus()
        {
            YKM_BusInfo busInfo_;
            ProCon.YKM_GetBusInfo(out busInfo_);
            if (0 != busInfo_.running)
                labelBusSts.Text = "运动中";
            else
                labelBusSts.Text = "正在初始化";
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            currentPos();
            sysStatus();
            goPosInc();
        }

        void goPosAbs(object obj)
        {
            UInt32 axis = 0;
            YKM_MoveAbsoluteConfig axis_abs = new YKM_MoveAbsoluteConfig();

            axis = (UInt32)obj;

            //判断轴是否在忙中，忙的时候不可以调用别的运动指令
            YKM_AxisStatus sta;
            ProCon.YKM_ReadAxisInfo(axis, out sta);
            if (0 != sta.Active)
                return;

            //设置位置，速度，加速度
            axis_abs.position = (double)pos.Value;
            axis_abs.acceleration = (double)acc.Value;
            axis_abs.decelerateion = (double)acc.Value * 10;
            axis_abs.jerk = 10000;
            axis_abs.velocity = (double)val.Value;

            //启动定位
            RetCode ret = ProCon.YKM_MoveAbsolute(axis, axis_abs);
            if (ret != RetCode.RET_OK)
            {
                MessageBox.Show("出错" + ret.ToString());
            }

            //判断完成信号
            ProCon.YKM_ReadAxisInfo(axis, out sta);
            while (1 != sta.Done)
            {
                Thread.Sleep(1);
                ProCon.YKM_ReadAxisInfo(axis, out sta);

                //由于别的原因停下了，如停止命令、碰限位
                if (0 == sta.Active)
                    break;
            }
        }

        private void buttonAxisAbs_Click(object sender, EventArgs e)
        {
            UInt32 axis = (UInt32)comboBoxAxisSel.SelectedIndex;
            Thread abs = new Thread(goPosAbs);
            abs.Start(axis);
        }

        private void buttonAxisInc_Click(object sender, EventArgs e)
        {
            inc_phase = 0;
            inc_cmd = true;
        }

        private void buttonAxisStop_Click(object sender, EventArgs e)
        {
            UInt32 axis = 0;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;
            ProCon.YKM_StopAxis(axis, 0);
            inc_cmd = false;
        }       
    }
}
