﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using YKCat2;
using System.Threading;

namespace DigitalIO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void buttonLoad_Click(object sender, EventArgs e)
        {
            RetCode result;
            //初始化函数，所有函数使用前必须要先初始化一次
            result = ProCon.YKM_LoadLib();
            if (result != RetCode.RET_OK)
            {
                MessageBox.Show("加载出错" + result.ToString());
                return;
            }

            buttonLoad.Enabled = false;
            buttonLoad.BackColor = Color.Green;

            //或者总线配置信息
            YKM_SysConfig config = new YKM_SysConfig();
            ProCon.YKM_GetSysConfig(out config);

            get_congfig(config);

        }

        void get_congfig(YKM_SysConfig sysInfo)
        {
            sysConfig.Items.Add("加密狗硬件序列号:" + sysInfo.dog_serial_number.ToString());
            sysConfig.Items.Add("");

            sysConfig.Items.Add("轴授权数量-轴使用数量:" + sysInfo.dog_axis_num.ToString() + "-" + sysInfo.dog_axis_used.ToString());
            sysConfig.Items.Add("");

            sysConfig.Items.Add("凸轮授权数量-凸轮使用数量:" + sysInfo.dog_ecam_num.ToString() + "-" + sysInfo.dog_ecam_used.ToString());
            sysConfig.Items.Add("");

            sysConfig.Items.Add("视觉授权标记-视觉使用标记:" + sysInfo.dog_vision_num.ToString() + "-" + sysInfo.dog_vision_used.ToString());
            sysConfig.Items.Add("");

            sysConfig.Items.Add("PLC授权标记-PLC使用标记:" + sysInfo.dog_plc_num.ToString() + "-" + sysInfo.dog_plc_used.ToString());
            sysConfig.Items.Add("");

            sysConfig.Items.Add("可视化授权标记-可视化使用标记:" + sysInfo.dog_hmi_num.ToString() + "-" + sysInfo.dog_hmi_used.ToString());
            sysConfig.Items.Add("");

            sysConfig.Items.Add("实时通讯授权标记-实时通讯使用标记:" + sysInfo.dog_comm_num.ToString() + "-" + sysInfo.dog_comm_used.ToString());
            sysConfig.Items.Add("");

            sysConfig.Items.Add("CAD授权标记-CAD使用标记:" + sysInfo.dog_cad_num.ToString() + "-" + sysInfo.dog_cad_used.ToString());
            sysConfig.Items.Add("");

            sysConfig.Items.Add("坐标系授权数量-坐标系使用数量:" + sysInfo.dog_crd_num.ToString() + "-" + sysInfo.dog_crd_used.ToString());
            sysConfig.Items.Add("");

            sysConfig.Items.Add("ECAT从站授权-ECAT从站使用标记:" + sysInfo.dog_ecslave_num + "-" + sysInfo.dog_ecam_used);
            sysConfig.Items.Add("");

            sysConfig.Items.Add("NoTime授权-NoTime使用标记:" + sysInfo.dog_dotNetRT_num + "-" + sysInfo.dog_dotNetRT_used);
            sysConfig.Items.Add("");

            sysConfig.Items.Add("授权日期管理标记-授权到期时间:" + sysInfo.dog_date_flag.ToString() + "："
                + sysInfo.dog_date_year.ToString() + "-" + sysInfo.dog_date_month.ToString() + "-" + sysInfo.dog_date_day.ToString());

            sysConfig.Items.Add("配置的轴数量:" + sysInfo.config_axis_num.ToString());
            sysConfig.Items.Add("");

            sysConfig.Items.Add("数字输入组数量:" + sysInfo.config_input_size.ToString());
            sysConfig.Items.Add("");
            
            sysConfig.Items.Add("数字输出组数量:" + sysInfo.config_output_size.ToString());
            sysConfig.Items.Add("");
        }

    }
}
