﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using YKCat2;

namespace DigitalIO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            styleOn = new System.Windows.Forms.DataGridViewCellStyle();
            styleOff = new System.Windows.Forms.DataGridViewCellStyle();
            styleOn.BackColor = System.Drawing.Color.Blue;
            styleOff.BackColor = System.Drawing.Color.White;
        }

        UInt32 input_size = 0;
        UInt32 ouput_size = 0;
        private void buttonLoad_Click(object sender, EventArgs e)
        {
            RetCode result;
            result = ProCon.YKM_LoadLib();
            if (result != RetCode.RET_OK)
            {
                MessageBox.Show("加载出错" + result.ToString());
                return;
            }
            ProCon.YKM_SetLogLevel(2);
            buttonLoad.Enabled = false;
            buttonLoad.BackColor = Color.Green;

            YKM_SysConfig config = new YKM_SysConfig();
            ProCon.YKM_GetSysConfig(out config);

            input_size = config.config_input_size;
            ouput_size = config.config_output_size;

            DIOSetGrid();

            timer1.Interval = 100;
            timer1.Enabled = true;
        }

        void DIOSetGrid()
        {
            dataGridViewInput.RowCount = (int)input_size;
            dataGridViewOutput.RowCount = (int)ouput_size;

            dataGridViewInput2.RowCount = (int)input_size;
            dataGridViewOutput2.RowCount = (int)ouput_size;

            dataGridView1.RowCount = (int)input_size;
            dataGridView2.RowCount = (int)input_size;
            //       dataGridView2.RowCount = (int)4;
            for (int idx = 0; idx < dataGridViewInput.RowCount; idx++)
            {
                dataGridViewInput.Rows[idx].HeaderCell.Value = "输入组" + idx.ToString();
                dataGridViewInput2.Rows[idx].HeaderCell.Value = "输入组" + idx.ToString();
                dataGridView1.Rows[idx].HeaderCell.Value = "输入组" + idx.ToString();
                dataGridView2.Rows[idx].HeaderCell.Value = "输入组" + idx.ToString();
                dataGridView1[0, idx].Value = '1';             
            }

            for (int idx = 0; idx < dataGridViewOutput.RowCount; idx++)
            {
                dataGridViewOutput.Rows[idx].HeaderCell.Value = "输出组" + idx.ToString();
                dataGridViewOutput2.Rows[idx].HeaderCell.Value = "输出组" + idx.ToString();
            }
        }

        System.Windows.Forms.DataGridViewCellStyle styleOn, styleOff;
        private void timer1_Tick(object sender, EventArgs e)
        {
            //数字输入输出
            DIO_get_set();
            sysStatus();
        }

        private void dataGridViewOutput_MouseDoubleClick(object sender, MouseEventArgs e)
        {

            DataGridViewCell cur = dataGridViewOutput.CurrentCell;
            if (null == cur)
                return;

            int grp = cur.RowIndex;
            int col = cur.ColumnIndex;
            byte val = 0;

            ProCon.YKM_ReadDigitalOutputByte((UInt32)grp, out val);
            Boolean bVal;
            if (0 == (val & (1 << col)))
                bVal = false;
            else
                bVal = true;
            if (bVal)
                ProCon.YKM_WriteDigitalOutputBit((UInt32)grp, (uint)col, 0);
            else
                ProCon.YKM_WriteDigitalOutputBit((UInt32)grp, (uint)col, 1);            
        }


        private void dataGridViewOutput2_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            DataGridViewCell cur = dataGridViewOutput2.CurrentCell;
            if (null == cur)
                return;

            int grp = cur.RowIndex;
            int col = cur.ColumnIndex;
            byte val = 0;

            ProCon.YKM_ReadDigitalOutputByte((UInt32)grp, out val);

            if (0 == (val & (1 << col)))
                val = (byte)(val | (1 << col));
            else
                val = (byte)(val & (~(1 << col)));

            ProCon.YKM_WriteDigitalOutputByte((UInt32)grp, val);
        }

        private void btn_setZero_Click(object sender, EventArgs e)
        {
            for (uint i = 0; i < input_size; i++)
            {
                for (uint x = 0; x < 8; x++)
                {
                   ProCon.YKM_WriteInputEdgeCount1(i, x, 0);
                }
            }
        }

        void DIO_get_set()
        {
            ///////////////////////////////////////////按bit
            //数字输入信号
            uint inVale = 0;
            int count = (int)input_size;
            if (count > dataGridViewInput.RowCount)
            {
                count = dataGridViewInput.RowCount;
            }
            for (int row = 0; row < count; row++)
            {
                for (int bit = 0; bit < 8; bit++)
                {
                    ProCon.YKM_ReadDigitalInputBit((uint)row, (uint)bit, out inVale);
                    if (0 == inVale)
                    {
                        dataGridViewInput[bit, row].Style = styleOff;
                    }
                    else
                    {
                        dataGridViewInput[bit, row].Style = styleOn;
                    }
                }
            }

            //数字输出信号
            uint outVale = 0;
            count = (int)ouput_size;
            if (count > dataGridViewOutput.RowCount)
            {
                count = dataGridViewOutput.RowCount;
            }
            for (int row = 0; row < count; row++)
            {
            //    ProCon.YKM_ReadDigitalOutputByte((UInt32)row, out outVale);
                for (int bit = 0; bit < 8; bit++)
                {
                    ProCon.YKM_ReadDigitalOutputBit((uint)row, (uint)bit, out outVale);
                    if (0 == outVale)
                    {
                        dataGridViewOutput[bit, row].Style = styleOff;
                    }
                    else
                    {
                        dataGridViewOutput[bit, row].Style = styleOn;
                    }
                }
            }
            
            //////////////////////////////////////按byte
            //数字输入信号
            byte inVale1 = 0;
            int count1 = (int)input_size;
            if (count > dataGridViewInput2.RowCount)
            {
                count = dataGridViewInput2.RowCount;
            }
            for (int row = 0; row < count1; row++)
            {
                ProCon.YKM_ReadDigitalInputByte((uint)row, out inVale1);
                for (int bit = 0; bit < 8; bit++)
                {
                    if (0 == (inVale1 & (1 << bit)))
                    {
                        dataGridViewInput2[bit, row].Style = styleOff;
                    }
                    else
                    {
                        dataGridViewInput2[bit, row].Style = styleOn;
                    }
                }
            }

            //数字输出信号
            count = (int)ouput_size;
            byte outVale1 = 0;
            if (count > dataGridViewOutput2.RowCount)
            {
                count = dataGridViewOutput2.RowCount;
            }
            for (int row = 0; row < count; row++)
            {
                ProCon.YKM_ReadDigitalOutputByte((UInt32)row, out outVale1);
                for (int bit = 0; bit < 8; bit++)
                {
                    if (0 == (outVale1 & (1 << bit)))
                    {
                        dataGridViewOutput2[bit, row].Style = styleOff;
                    }
                    else
                    {
                        dataGridViewOutput2[bit, row].Style = styleOn;
                    }
                }
            }

            //滤波
            uint inVale_ms = 0;
            count = (int)input_size;
            if (count > dataGridView1.RowCount)
            {
                count = dataGridView1.RowCount;
            }
            for (int row = 0; row < count; row++)
            {
                inVale_ms = uint.Parse(dataGridView1[0, row].Value.ToString());
        
                ProCon.YKM_WriteDigitalInputFilter((uint)row, inVale_ms);
            }

            //上升沿计数
            inVale = 0;
            count = (int)input_size;
            if (count > dataGridView2.RowCount)
            {
                count = dataGridView2.RowCount;
            }
            for (int row = 0; row < count; row++)
            {
                for (int bit = 0; bit < 8; bit++)
                {
                    ProCon.YKM_ReadInputEdgeCount1((uint)row, (uint)bit, out inVale);
                    dataGridView2[bit, row].Value = inVale.ToString();
 
                }
            }
        }


        void sysStatus()
        {
            YKM_BusInfo busInfo_;
            ProCon.YKM_GetBusInfo(out busInfo_);
            if (0 != busInfo_.running)
                labelBusSts.Text = "运动中";
            else
                labelBusSts.Text = "正在初始化";

        }
    }
}
