﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using YKCat2;

namespace DigitalIO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            label7.Text = "";
        }

        UInt32 axis_size = 0;

        private void buttonLoad_Click(object sender, EventArgs e)
        {
            RetCode result;
            //初始化函数，所有函数使用前必须要先初始化一次
            result = ProCon.YKM_LoadLib();
            if (result != RetCode.RET_OK)
            {
                MessageBox.Show("加载出错" + result.ToString());
                return;
            }

            buttonLoad.Enabled = false;
            buttonLoad.BackColor = Color.Green;

            //或者总线配置信息
            YKM_SysConfig config = new YKM_SysConfig();
            ProCon.YKM_GetSysConfig(out config);
            axis_size = config.config_axis_num;

            comboBoxAxisSel.Items.Clear();
            for (int idx = 0; idx < axis_size; idx++)
            {
                comboBoxAxisSel.Items.Add(idx.ToString());
            }
            comboBoxAxisSel.SelectedIndex = 0;

            timer1.Enabled = true;
        }

        void currentPos()
        {
            UInt32 axis = 0;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;
            double pos;
            ProCon.YKM_ReadActualPosition(axis, out pos);
            current.Text = pos.ToString();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            currentPos();
            sysStaus();
        }

        private void buttonAxisAbs_Click(object sender, EventArgs e)
        {
            UInt32 axis = 0;
            YKM_HomeConfig axis_abs = new YKM_HomeConfig();
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;

            //判断轴是否在忙中，忙的时候不可以调用别的运动指令
            YKM_AxisStatus sta;
            ProCon.YKM_ReadAxisInfo(axis, out sta);
            if (0 != sta.Active)
                return;

            axis_abs.mode = (YKM_HOME_MODE)homemode.Value;
            axis_abs.acceleration = (double)acc.Value;
            axis_abs.offset = 100;
            axis_abs.probelMove = 100;
            axis_abs.velHigh = (double)val.Value;
            axis_abs.velLow = (double)val.Value / 10;
            axis_abs.switchMove = 10000;

            ProCon.YKM_StartHome(axis, axis_abs);
        }

        private void butt_stop_Click(object sender, EventArgs e)
        {
            UInt32 axis = 0;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;
            ProCon.YKM_StopAxis(axis, 0);
        }

        void sysStaus()
        {
            YKM_BusInfo busInfo_;
            ProCon.YKM_GetBusInfo(out busInfo_);
            if (0 != busInfo_.running)
                labelBusSts.Text = "运动中";
            else
                labelBusSts.Text = "正在初始化";

            UInt32 axis = 0;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;
            YKM_AxisStatus sta;
            ProCon.YKM_ReadAxisInfo(axis, out sta);

            if (0 != sta.Done)
                label7.Text = "回零完成";
            else if (0 != sta.Active)
                label7.Text = "运动中";
            else
                label7.Text = "空闲";
        }
    }
}
