﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using YKCat2;
using System.Threading;

namespace DigitalIO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            styleOn = new System.Windows.Forms.DataGridViewCellStyle();
            styleOff = new System.Windows.Forms.DataGridViewCellStyle();
            styleOn.BackColor = System.Drawing.Color.Blue;
            styleOff.BackColor = System.Drawing.Color.White;
        }

        UInt32 axis_size;

        private void buttonLoad_Click(object sender, EventArgs e)
        {
            RetCode result;
            //初始化函数，所有函数使用前必须要先初始化一次
            result = ProCon.YKM_LoadLib();
            if (result != RetCode.RET_OK)
            {
                MessageBox.Show("加载出错" + result.ToString());
                return;
            }

            buttonLoad.Enabled = false;
            buttonLoad.BackColor = Color.Green;

            //或者总线配置信息
            YKM_SysConfig config = new YKM_SysConfig();
            ProCon.YKM_GetSysConfig(out config);
            axis_size = config.config_axis_num;

            axisCirDir.SelectedIndex = 1;
            axisTranMode.SelectedIndex = 3;
            bufferMode.SelectedIndex = 2;
            axisCirMode.SelectedIndex = 0;
            dataGridViewInput.RowCount = 1;
            groupOutputOnOff.SelectedIndex = 0;
            timer1.Enabled = true;
            timer2.Enabled = true;
        }
        void currentPos()
        {
            UInt32 axis = 0;
            axis = (UInt32)bufferMode.SelectedIndex;
            double pos;
            ProCon.YKM_ReadActualPosition((uint)axisNumberX.Value, out pos);
            axisPosX.Value = (decimal)pos;

            ProCon.YKM_ReadActualPosition((uint)axisNumberY.Value, out pos);
            axisPosY.Value = (decimal)pos;

            ProCon.YKM_ReadActualPosition((uint)axisNumberZ.Value, out pos);
            axisPosZ.Value = (decimal)pos;
        }
        bool abs = false;
        bool inc = false;
        void goPos_inc()
        {
            if (inc)
            {
                UInt32 axis = 0;
                YKM_MoveRelativeConfig axis_inc = new YKM_MoveRelativeConfig();
                axis = (UInt32)bufferMode.SelectedIndex;

                //判断轴是否在忙中，忙的时候不可以调用别的运动指令
                YKM_AxisStatus sta;
                ProCon.YKM_ReadAxisInfo(axis, out sta);
                if (0 != sta.Active)
                    return;

                axis_inc.distance = (double)axisNum.Value;
                axis_inc.acceleration = (double)axisVelocity.Value;
                axis_inc.decelerateion = (double)axisVelocity.Value * 10;
                axis_inc.jerk = 10000;
                axis_inc.velocity = (double)axisNumberX.Value;

                ProCon.YKM_MoveRelative(axis, axis_inc);
                //判断完成信号
                ProCon.YKM_ReadAxisInfo(axis, out sta);
                while (1 != sta.Done)
                {
                    Thread.Sleep(2);
                    ProCon.YKM_ReadAxisInfo(axis, out sta);
                }
               
                inc = false;
            }
        }
        void goPos()
        {
            if (abs)
            {
                UInt32 axis = 0;
                YKM_MoveAbsoluteConfig axis_abs = new YKM_MoveAbsoluteConfig();

                axis = (UInt32)bufferMode.SelectedIndex;

                //判断轴是否在忙中，忙的时候不可以调用别的运动指令
                YKM_AxisStatus sta;
                ProCon.YKM_ReadAxisInfo(axis, out sta);
                if (0 != sta.Active)
                    return;

                //设置位置，速度，加速度
                axis_abs.position = (double)axisNum.Value;
                axis_abs.acceleration = (double)axisVelocity.Value;
                axis_abs.decelerateion = (double)axisVelocity.Value * 10;
                axis_abs.jerk = 10000;
                axis_abs.velocity = (double)axisNumberX.Value;

                //启动定位
                RetCode ret = ProCon.YKM_MoveAbsolute(axis, axis_abs);
                if (ret != RetCode.RET_OK)
                {
                    MessageBox.Show("出错" + ret.ToString());
                }
                //判断完成信号
                ProCon.YKM_ReadAxisInfo(axis, out sta);
                while (1 != sta.Done)
                {
                    Thread.Sleep(2);
                    ProCon.YKM_ReadAxisInfo(axis, out sta);
                }
                abs = false;
            }
        }
        private void timer1_Tick(object sender, EventArgs e)
        {
            currentPos();
            sys_();
            axis_sta();
        }

        private void buttonAxisAbs_Click(object sender, EventArgs e)
        {

            YKM_MoveLinearAbsoluteConfig moveLinearAbsoluteConfig = new YKM_MoveLinearAbsoluteConfig();
            moveLinearAbsoluteConfig.acceleration = (double)axisVelocity.Value * 10.0;
            moveLinearAbsoluteConfig.velocity = (double)axisVelocity.Value;
            moveLinearAbsoluteConfig.transMode = (YKM_TransitionMode)axisTranMode.SelectedIndex;
            moveLinearAbsoluteConfig.transPara.x = (double)axisTransParaX.Value;
            moveLinearAbsoluteConfig.transPara.y = (double)axisTransParaY.Value;
            moveLinearAbsoluteConfig.transPara.z = (double)axisTransParaZ.Value;
            moveLinearAbsoluteConfig.bufferMode = (YKM_BufferMode)bufferMode.SelectedIndex;
            moveLinearAbsoluteConfig.jerk = (double)axisVelocity.Value * 100.0;
            moveLinearAbsoluteConfig.position.x = (double)axisTargetPosX.Value;
            moveLinearAbsoluteConfig.position.y = (double)axisTargetPosY.Value;
            moveLinearAbsoluteConfig.position.z = (double)axisTargetPosZ.Value;

            ProCon.YKM_MoveLinearAbsolute(0, moveLinearAbsoluteConfig);
            return;
        }
        System.Windows.Forms.DataGridViewCellStyle styleOn, styleOff;
        void axis_sta()
        {
            UInt32 axis = 0;
            // axis = 0;// (UInt32)comboBoxAxisSel.SelectedIndex;
            YKM_GroupStatus GroupStatus;
            int offset = 0;
            ProCon.YKM_GetGroupStatus(axis, out GroupStatus);

            if (GroupStatus.Inited == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (GroupStatus.Acitve == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (GroupStatus.Done == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (GroupStatus.Warnning == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            dataGridViewInput[offset++, 0].Value = (YKM_MC_ERRER)GroupStatus.WarnID;

            dataGridViewInput[offset++, 0].Value = GroupStatus.WarnM;
            dataGridViewInput[offset++, 0].Value = GroupStatus.BufferIdel;
            dataGridViewInput[offset++, 0].Value = GroupStatus.traveledLength;

        }

        private void butt_stop_Click(object sender, EventArgs e)
        {
            ProCon.YKM_StopGroup(0);
        }

        void sys_()
        {
            YKM_BusInfo busInfo_;
            ProCon.YKM_GetBusInfo(out busInfo_);
            if (0 != busInfo_.running)
                labelBusSts.Text = "运动中";
            else
                labelBusSts.Text = "正在初始化";


        }

        private void timer2_Tick(object sender, EventArgs e)
        {

        }

        private void btnStartGroup_Click(object sender, EventArgs e)
        {
            //配置基本参数
            YKM_GroupProfile groupProfile = new YKM_GroupProfile();
            groupProfile.start_velocity = 1;
            groupProfile.max_velocity = 1000;
            groupProfile.stop_dec_emg = (double)axisVelocity.Value * 10.0;
            groupProfile.stop_dec_smooth = (double)axisVelocity.Value * 10.0;
            groupProfile.stop_dec_jerk = (double)axisVelocity.Value * 100.0;
            ProCon.YKM_SetGroupProfile(0, groupProfile);

            YKM_GroupConfig groupConfig = new YKM_GroupConfig();
            groupConfig.axisIndex0 = (uint)axisNumberX.Value;
            groupConfig.axisIndex1 = (uint)axisNumberY.Value;
            groupConfig.axisIndex2 = (uint)axisNumberZ.Value;
            groupConfig.axisNum = (uint)axisNum.Value;

            RetCode ret = ProCon.YKM_InitGroup(0, groupConfig);


        }

        private void butAddIncMotion_Click(object sender, EventArgs e)
        {
            YKM_MoveLinearRelativeConfig moveLinearRelativeConfig = new YKM_MoveLinearRelativeConfig();
            moveLinearRelativeConfig.acceleration = (double)axisVelocity.Value * 10.0;
            moveLinearRelativeConfig.velocity = (double)axisVelocity.Value;
            moveLinearRelativeConfig.transMode = (YKM_TransitionMode)axisTranMode.SelectedIndex;
            moveLinearRelativeConfig.transPara.x = (double)axisTransParaX.Value;
            moveLinearRelativeConfig.transPara.y = (double)axisTransParaY.Value;
            moveLinearRelativeConfig.transPara.z = (double)axisTransParaZ.Value;
            moveLinearRelativeConfig.bufferMode = (YKM_BufferMode)bufferMode.SelectedIndex;
            moveLinearRelativeConfig.jerk = (double)axisVelocity.Value * 100.0;
            moveLinearRelativeConfig.distance.x = (double)axisTargetPosX.Value;
            moveLinearRelativeConfig.distance.y = (double)axisTargetPosY.Value;
            moveLinearRelativeConfig.distance.z = (double)axisTargetPosZ.Value;
            for (int i = 0; i < 1; i++)
            {
                ProCon.YKM_MoveLinearRelative(0, moveLinearRelativeConfig);
            }
           
            return;
        }

        private void btnAddCirAbsMotion_Click(object sender, EventArgs e)
        {
            YKM_MoveCircularAbsoluteConfig MoveCircularAbsoluteConfig = new YKM_MoveCircularAbsoluteConfig();
            MoveCircularAbsoluteConfig.acceleration = (double)axisVelocity.Value * 10.0;
            MoveCircularAbsoluteConfig.velocity = (double)axisVelocity.Value;
            MoveCircularAbsoluteConfig.transMode = (YKM_TransitionMode)axisTranMode.SelectedIndex;
            MoveCircularAbsoluteConfig.transPara.x = (double)axisTransParaX.Value;
            MoveCircularAbsoluteConfig.transPara.y = (double)axisTransParaY.Value;
            MoveCircularAbsoluteConfig.transPara.z = (double)axisTransParaZ.Value;
            MoveCircularAbsoluteConfig.bufferMode = (YKM_BufferMode)bufferMode.SelectedIndex;
            MoveCircularAbsoluteConfig.jerk = (double)axisVelocity.Value * 100.0;
            MoveCircularAbsoluteConfig.endPoint.x = (double)axisTargetPosX.Value;
            MoveCircularAbsoluteConfig.endPoint.y = (double)axisTargetPosY.Value;
            MoveCircularAbsoluteConfig.endPoint.z = (double)axisTargetPosZ.Value;
            MoveCircularAbsoluteConfig.auxPoint.x = (double)axisCircularPosX.Value;
            MoveCircularAbsoluteConfig.auxPoint.y = (double)axisCircularPosY.Value;
            MoveCircularAbsoluteConfig.auxPoint.z = (double)axisCircularPosZ.Value;
            MoveCircularAbsoluteConfig.pathChoice = (YKM_CircularPathChoice)axisCirDir.SelectedIndex;
            MoveCircularAbsoluteConfig.auxMode = (YKM_CircularAuxMode)axisCirMode.SelectedIndex;

            ProCon.YKM_MoveCircularAbsolute(0, MoveCircularAbsoluteConfig);
            return;
        }

        private void btnAddCirIncMotion_Click(object sender, EventArgs e)
        {
            YKM_MoveCircularRelativeConfig MoveCircularRelativeConfig = new YKM_MoveCircularRelativeConfig();
            MoveCircularRelativeConfig.acceleration = (double)axisVelocity.Value * 10.0;
            MoveCircularRelativeConfig.velocity = (double)axisVelocity.Value;
            MoveCircularRelativeConfig.transMode = (YKM_TransitionMode)axisTranMode.SelectedIndex;
            MoveCircularRelativeConfig.transPara.x = (double)axisTransParaX.Value;
            MoveCircularRelativeConfig.transPara.y = (double)axisTransParaY.Value;
            MoveCircularRelativeConfig.transPara.z = (double)axisTransParaZ.Value;
            MoveCircularRelativeConfig.bufferMode = (YKM_BufferMode)bufferMode.SelectedIndex;
            MoveCircularRelativeConfig.jerk = (double)axisVelocity.Value * 100.0;
            MoveCircularRelativeConfig.endPoint.x = (double)axisTargetPosX.Value;
            MoveCircularRelativeConfig.endPoint.y = (double)axisTargetPosY.Value;
            MoveCircularRelativeConfig.endPoint.z = (double)axisTargetPosZ.Value;
            MoveCircularRelativeConfig.auxPoint.x = (double)axisCircularPosX.Value;
            MoveCircularRelativeConfig.auxPoint.y = (double)axisCircularPosY.Value;
            MoveCircularRelativeConfig.auxPoint.z = (double)axisCircularPosZ.Value;
            MoveCircularRelativeConfig.pathChoice = (YKM_CircularPathChoice)axisCirDir.SelectedIndex;
            MoveCircularRelativeConfig.auxMode = (YKM_CircularAuxMode)axisCirMode.SelectedIndex;

            ProCon.YKM_MoveCircularRelative(0, MoveCircularRelativeConfig);
            return;
        }

        private void btnAddOutputTime_Click(object sender, EventArgs e)
        {
            YKM_POINT3 pos = new YKM_POINT3();
            pos.x = (double)proupOutputPosX.Value;
            pos.y = (double)proupOutputPosY.Value;
            pos.z = (double)proupOutputPosZ.Value;

            ProCon.YKM_GroupOutputTime(0, pos, 0, (uint)groupOutputIndex.Value, (uint)groupOutputOnOff.SelectedIndex, (double)groupOutputTim.Value);

        }

        private void btnGroupClearWarn_Click(object sender, EventArgs e)
        {
            ProCon.YKM_ClearGroupWarn(0);
        }

        private void btnDeinitGroup_Click(object sender, EventArgs e)
        {
            ProCon.YKM_DeInitGroup(0);
        }

        private void btnAddOutputDist_Click(object sender, EventArgs e)
        {
            YKM_POINT3 pos = new YKM_POINT3();
            pos.x = (double)proupOutputPosX.Value;
            pos.y = (double)proupOutputPosY.Value;
            pos.z = (double)proupOutputPosZ.Value;

            ProCon.YKM_GroupOutputDist(0, pos, 0, (uint)groupOutputIndex.Value, (uint)groupOutputOnOff.SelectedIndex, (double)groupOutputDist.Value);

        }
    }
}
