﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using YKCat2;

namespace DigitalIO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

        }

        UInt32 axis_size;

        private void buttonLoad_Click(object sender, EventArgs e)
        {
            RetCode result;
            //初始化函数，所有函数使用前必须要先初始化一次
            result = ProCon.YKM_LoadLib();
            if (result != RetCode.RET_OK)
            {
                MessageBox.Show("加载出错" + result.ToString());
                return;
            }
        
            buttonLoad.Enabled = false;
            buttonLoad.BackColor = Color.Green;

            //或者总线配置信息
            YKM_SysConfig config = new YKM_SysConfig();
            ProCon.YKM_GetSysConfig(out config);
            axis_size = config.config_axis_num;

            if (axis_size < 2)
            {
                MessageBox.Show("配置轴数量少于2，无法插补");
                return;
            }
            comboBoxAxisSel.Items.Clear();
            for (int idx = 0; idx < axis_size; idx++)
            {
                if (idx >= (axis_size - 1)) 
                {
                    comboBoxAxisSel.Items.Add(idx.ToString());
                }


                //设置当量
                ProCon.YKM_SetCommandEquiv((uint)idx, 1, 1000);
                ProCon.YKM_SetFeedbackEquiv((uint)idx, 1, 1000);
            }
            comboBoxAxisSel.SelectedIndex = 0;


            timer1.Enabled = true;


        }
        void currentPos()
        {
            UInt32 axis = 0;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;
            double pos;
            ProCon.YKM_ReadActualPosition(axis, out pos);
            current.Value = (decimal)pos;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            currentPos();
            sys_();
        }

        private void buttonAxisAbs_Click(object sender, EventArgs e)
        {
            UInt32 axis = 0;
            YKM_MoveLinearAbsoluteConfig axis_abs;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;

            //判断轴是否在忙中，忙的时候不可以调用别的运动指令
            YKM_AxisStatus sta;
            ProCon.YKM_ReadAxisInfo(axis, out sta);
            if (0 != sta.Acitve)
                return;

            //判断轴是否在忙中，忙的时候不可以调用别的运动指令
            ProCon.YKM_ReadAxisInfo(axis+1, out sta);
            if (0 != sta.Acitve)
                return;

            //设置轴参数
            init(axis);
            init(axis + 1);
            //初始化坐标系
            init_Group(axis);

            axis_abs.position.x =(double)pos.Value;
            axis_abs.position.y = (double)pos2.Value;
            axis_abs.position.z = (double)pos.Value;

            axis_abs.acceleration = (double)acc.Value;
            axis_abs.decelerateion = (double)acc.Value * 10;
            axis_abs.jerk = 10000;
            axis_abs.velocity = (double)val.Value;

            axis_abs.bufferMode = YKM_BufferMode.YKM_BLENDING_NEXT;
            axis_abs.transMode = YKM_TransitionMode.MAX_CORNER_DEVIATION;
            axis_abs.transPara.x = 2;
            axis_abs.transPara.y = 2;
            axis_abs.transPara.z = 2;

            axis_abs.res1 = 0;
            axis_abs.res2 = 0;
            axis_abs.res3 = 0;
            axis_abs.res4 = 0;

            ProCon.YKM_MoveLinearAbsolute(0, axis_abs);

        }


        void init_Group(uint axis)
        {
            YKM_GroupProfile axis_pro;
            YKM_GroupConfig config;

            axis_pro.max_velocity = 1000;
            axis_pro.start_velocity = 1;
            axis_pro.stop_dec_emg = 1000;
            axis_pro.stop_dec_jerk = 1000;
            axis_pro.stop_dec_smooth = 0;
            axis_pro.overAcc = 0;
            axis_pro.overJerk = 0;
            axis_pro.overVel = 10;

            axis_pro.res1 = 0;
            axis_pro.res2 = 0;
            axis_pro.res3 = 0;
            axis_pro.res4 = 0;

            config.axisIndex1 = axis;
            config.axisIndex2 = axis + 1;
            config.axisIndex3 = 0;
            config.axisNum = 2;
            config.System = YKM_GroupSystem.YKM_COORDINATE_ACS;
            config.res1 = 0;
            config.res2 = 0;
            config.res3 = 0;
            config.res4 = 0;

            ProCon.YKM_SetGroupProfile(0, axis_pro);
            ProCon.YKM_InitGroup(0, config);

        }
        private void but_inc_Click(object sender, EventArgs e)
        {
            UInt32 axis = 0;
            YKM_MoveRelativeConfig axis_inc;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;

            init(axis);
            axis_inc.distance = (double)pos.Value;
            axis_inc.acceleration = (double)acc.Value;
            axis_inc.decelerateion = (double)acc.Value * 10;
            axis_inc.jerk = 10000;
            axis_inc.velocity = (double)val.Value;
            axis_inc.res1 = 0;
            axis_inc.res2 = 0;
            axis_inc.res3 = 0;
            axis_inc.res4 = 0;

            ProCon.YKM_MoveRelative(axis, axis_inc);
        }


        void init(uint axis)
        {
            YKM_AxisProfile axis_pro;
            axis_pro.inp = 10;
            axis_pro.max_velocity = 1000;
            axis_pro.start_velocity = 1;
            axis_pro.stop_dec_emg = 1000;
            axis_pro.stop_dec_jerk = 1000;
            axis_pro.stop_dec_smooth = 0;
            axis_pro.follow = 0;

            axis_pro.res1 = 0;
            axis_pro.res10 = 0;
            axis_pro.res2 = 0;
            axis_pro.res3 = 0;
            axis_pro.res4 = 0;
            axis_pro.res5 = 0;
            axis_pro.res6 = 0;
            axis_pro.res7 = 0;
            axis_pro.res8 = 0;
            axis_pro.res9 = 0;
 

            ProCon.YKM_SetAxisProfile(axis, axis_pro);
        }

        private void butt_stop_Click(object sender, EventArgs e)
        {
            ProCon.YKM_StopGroup(0);

        }

        void sys_()
        {
            YKM_BusInfo busInfo_;
            ProCon.YKM_GetBusInfo(out busInfo_);
            if (0 != busInfo_.running)
                labelBusSts.Text = "运动中";
            else
                labelBusSts.Text = "正在初始化";

        }
    }
}
