﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using YKCat2;
using System.Threading;

namespace MtionComPensation
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        UInt32 axis_size;

        private void buttonLoad_Click(object sender, EventArgs e)
        {
            RetCode result;
            //初始化函数，所有函数使用前必须要先初始化一次
            result = ProCon.YKM_LoadLib();
            if (result != RetCode.RET_OK)
            {
                MessageBox.Show("加载出错" + result.ToString());
                return;
            }

            buttonLoad.Enabled = false;
            buttonLoad.BackColor = Color.Green;

            //或者总线配置信息
            YKM_SysConfig config = new YKM_SysConfig();
            ProCon.YKM_GetSysConfig(out config);
            axis_size = config.config_axis_num;

        }

     
     
        private void timer1_Tick(object sender, EventArgs e)
        {
            sys_();
        }

        void sys_()
        {
            YKM_BusInfo busInfo_;
            ProCon.YKM_GetBusInfo(out busInfo_);
            if (0 != busInfo_.running)
                labelBusSts.Text = "运动中";
            else
                labelBusSts.Text = "正在初始化";


        }

        private void PitchError1DEn_Click(object sender, EventArgs e)
        {
            uint axis = (uint)axisNumberX.Value;

            YKM_PitchError1DConfig pitchEror1DConfig = new YKM_PitchError1DConfig();

            pitchEror1DConfig.originIndex = (UInt32)originIndex1D.Value;
            pitchEror1DConfig.count = (UInt32)count1D.Value;
            pitchEror1DConfig.originPosition = (double)originPosition1D.Value;
            pitchEror1DConfig.pitchInterval = (double)pitchInterval1D.Value;
            pitchEror1DConfig.catchUpVel = (double)catchUpVel.Value;
            pitchEror1DConfig.catchUpAcc = (double)catchUpAcc.Value;


            ProCon.YKM_SetPitchError1DConfig(axis, pitchEror1DConfig);

            pitchEror1DConfig = new YKM_PitchError1DConfig();
            ProCon.YKM_GetPitchError1DConfig(axis, out pitchEror1DConfig);


            ProCon.YKM_SetPitchError1DData(axis, 10, new double[] { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 });
            double[] errorData = new double[10];
            ProCon.YKM_GetPitchError1DData(axis, 10, errorData);

            ProCon.YKM_EnablePitchError1D(axis);


        }

        private void PitchError2DEn_Click(object sender, EventArgs e)
        {
            uint axis1 = (uint)axisNumber2d1.Value;
            uint axis2 = (uint)axisNumber2d2.Value;

            YKM_PitchError2DConfig pitchEror2DConfig = new YKM_PitchError2DConfig();

            pitchEror2DConfig.axisIndex0 = axis1;
            pitchEror2DConfig.originIndex0 = (UInt32)originIndex2D1.Value;
            pitchEror2DConfig.count0 = (UInt32)count2D1.Value;
            pitchEror2DConfig.originPosition0 = (double)originPosition2D1.Value;
            pitchEror2DConfig.pitchInterval0 = (double)pitchInterval2D1.Value;

            pitchEror2DConfig.originIndex1 = (UInt32)originIndex2D2.Value;
            pitchEror2DConfig.count1 = (UInt32)count2D2.Value;
            pitchEror2DConfig.originPosition1 = (double)originPosition2D2.Value;
            pitchEror2DConfig.pitchInterval1 = (double)pitchInterval2D2.Value;

            pitchEror2DConfig.axisIndex1 = axis2;
            pitchEror2DConfig.catchUpVel = (double)catchUpVel.Value;
            pitchEror2DConfig.catchUpAcc = (double)catchUpAcc.Value;


            ProCon.YKM_SetPitchError2DConfig(axis1, pitchEror2DConfig);
            ProCon.YKM_SetPitchError2DConfig(axis2, pitchEror2DConfig);

            pitchEror2DConfig = new YKM_PitchError2DConfig();
            ProCon.YKM_GetPitchError2DConfig(axis1, out pitchEror2DConfig);
            ProCon.YKM_GetPitchError2DConfig(axis2, out pitchEror2DConfig);

            RetCode r = ProCon.YKM_SetPitchError2DData(axis1, 20, new double[] { 1, 2, 3, 4, 5, 2, 3, 4, 5, 6, 3, 4, 5, 6, 7, 4, 5, 6, 7, 8 });
            ProCon.YKM_SetPitchError2DData(axis2, 20, new double[] { 1, 2, 3, 4, 5, 2, 3, 4, 5, 6, 3, 4, 5, 6, 7, 4, 5, 6, 7, 8});

            double[] errorData = new double[20];
            r = ProCon.YKM_GetPitchError2DData(axis1, 20, errorData);
            r = ProCon.YKM_GetPitchError2DData(axis2, 20, errorData);

            r = ProCon.YKM_EnablePitchError2D(axis1);
            r = ProCon.YKM_EnablePitchError2D(axis2);
        }

        private void PitchError2DUnEn_Click(object sender, EventArgs e)
        {
            uint axis1 = (uint)axisNumber2d1.Value;
            uint axis2 = (uint)axisNumber2d2.Value;
            RetCode r = ProCon.YKM_DisablePitchError2D(axis1);
            r = ProCon.YKM_DisablePitchError2D(axis2);

        }

        private void PitchError1DUnEn_Click(object sender, EventArgs e)
        {
            uint axis = (uint)axisNumberX.Value;
            ProCon.YKM_DisablePitchError1D(axis);
        }

     
    }
}
