﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using NoLib;
using YKCat2;
namespace csapp
{
    class Program
    {
        /// <summary>
        ///  共享内存名称
        /// </summary>
        const string MEM_NAME = "memtick";
        /// <summary>
        /// 共享内存大小()
        /// </summary>
        const int MEM_SIZE = 10;
        private static bool mCancel = false;
        private static int flow = 0;
        /// <summary>
        /// 创建共享内存
        /// </summary>
        /// <returns></returns>
        public static bool CreateShareMemory()
        {
            NoCode code = NoSys.NOS_CreateShareMemory(MEM_NAME, MEM_SIZE);
            code = NoSys.NOS_WriteShareMemory(MEM_NAME, 0, MEM_SIZE, new int[MEM_SIZE]);
            return code == NoCode.RET_OK;
        }

        /// <summary>
        /// 创建线程
        /// </summary>
        public static void StartMonitor1()
        {
            System.Threading.Thread a = new System.Threading.Thread(threadFlow);
            a.Start();
        }

        public static int aPos, bPos;
        /// <summary>
        /// 读取共享内存数据
        /// </summary>
        /// <returns></returns>
        public static int[] ReadShareMemory()
        {
            int[] vals = new int[MEM_SIZE];
            string name = MEM_NAME;
            NoSys.NOS_ReadShareMemory(name, 0, MEM_SIZE, vals);
            if (vals[0] == 1)
            {
                if (!mCancel)
                {
                    mCancel = true;
                    flow = 1;
                }
              
            }
            else
            {
                if (mCancel)
                {
                    mCancel = false;
                }
              
            }
            aPos = vals[1];
            bPos = vals[2];
            return vals;
        }
        /// <summary>
        /// 往复运动流程
        /// </summary>
        static void threadFlow()
        {
            YKM_MoveAbsoluteConfig AbsoluteConfig = new YKM_MoveAbsoluteConfig();
            AbsoluteConfig.velocity = 100;
            AbsoluteConfig.acceleration = AbsoluteConfig.velocity * 10;
            AbsoluteConfig.jerk = AbsoluteConfig.velocity * 100;
            while (true)
            {
                System.Threading.Thread.Sleep(1);
                ReadShareMemory();
                if (mCancel)
                {
                    if (flow == 1)
                    {
                        YKM_AxisStatus AxisStatus;
                        ProCon.YKM_ReadAxisInfo(0, out AxisStatus);
                        if (AxisStatus.Active == 0)
                        {
                            flow = 2;
                        }
                       
                    }
                    else if (flow == 2)
                    {
                        AbsoluteConfig.position = aPos;
                        ProCon.YKM_MoveAbsolute(0, AbsoluteConfig);
                        flow = 3;
                    }
                    else if (flow == 3)
                    {
                        YKM_AxisStatus AxisStatus;
                        ProCon.YKM_ReadAxisInfo(0, out AxisStatus);
                        if (AxisStatus.Active == 0)
                        {
                            flow = 4;
                        }
                       
                    }
                    else if (flow == 4)
                    {
                        AbsoluteConfig.position = bPos;
                        ProCon.YKM_MoveAbsolute(0, AbsoluteConfig);
                        flow = 1;
                    }
                }
            }
        }
        /// <summary>
        /// main函数，程序入口
        /// </summary>
        /// <param name="args"></param>
        static void Main(string[] args)
        {
            PrintfCS("hello world ProCon");

            var ret = ProCon.YKM_LoadLib();
            NoSys.PrintfCS($"YKM_LoadLib {ret}");

            if (ret == RetCode.RET_OK)
            {
                bool flag = CreateShareMemory();
                PrintfCS("CreateShareMemory" + flag.ToString());
                if (flag)
                {
                    System.Threading.Thread.Sleep(1000);
                    StartMonitor1();
                    while (true)
                    {
                        System.Threading.Thread.Sleep(1000);
                    }
                   
                }
            }
        }

        /// <summary>
        /// 打印函数
        /// </summary>
        /// <param name="content"></param>
        /// <returns></returns>
        public static int PrintfCS(string content)
        {
            NoLib.NoSys.PrintfCS(content);
            return 0;
#if INTIME
            NoLib.NoSys.PrintfCS(content);
#else
            System.Diagnostics.Debug.WriteLine(content);
            Console.WriteLine(content);
#endif
            return 0;
        }
    }
}
