﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using YKCat2;

namespace DigitalIO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            comboBoxPdoLen.Items.Add("8位");
            comboBoxPdoLen.Items.Add("16位");
            comboBoxPdoLen.Items.Add("32位");
            comboBoxPdoLen.SelectedIndex = 0;

            comboBoxSdo.Items.Add("8位");
            comboBoxSdo.Items.Add("16位");
            comboBoxSdo.Items.Add("32位");
            comboBoxSdo.SelectedIndex = 0;
        }

        private void buttonLoad_Click(object sender, EventArgs e)
        {
            RetCode result;
            //初始化函数，所有函数使用前必须要先初始化一次
            result = ProCon.YKM_LoadLib();
            if (result != RetCode.RET_OK)
            {
                MessageBox.Show("加载出错" + result.ToString());
                return;
            }
            ProCon.YKM_SetLogLevel(2);
            buttonLoad.Enabled = false;
            buttonLoad.BackColor = Color.Green;

            timer1.Enabled = true;
        }


        private void timer1_Tick(object sender, EventArgs e)
        {
            sys_();
            sdo_read_write();
        }

        void sdo_read_write()
        {
            if (0 != sdoIndex)
            {
                uint valid, val;
                ProCon.YKM_ReadSDOStatus(sdoIndex, out valid, out val);
                if (1 == valid)
                {
                    sdoIndex = 0;
                    numericUpDownSdoValue.Value = val;
                }
            }
        }
        void sys_()
        {
            YKM_BusInfo busInfo_;
            ProCon.YKM_GetBusInfo(out busInfo_);
            if (0 != busInfo_.running)
                labelBusSts.Text = "运动中";
            else
                labelBusSts.Text = "正在初始化";

        }

        private void buttonPdoRead_Click(object sender, EventArgs e)
        {
            UInt32 Uidx = (UInt32)numericUpDownPdoNo.Value;
            UInt32 Gidx = (UInt32)numericUpDownPdoG.Value;

            UInt16[] ret = new UInt16[2];

            RetCode RET = ProCon.YKM_ReadPDO(Uidx, Gidx, ret, 2);

            int val = 0;
            if (0 == comboBoxPdoLen.SelectedIndex)
            {
                ret[0] &= 0xFF;
                short s = (short)ret[0];
                val = (int)s;
            }
            else if (1 == comboBoxPdoLen.SelectedIndex)
            {
                short s = (short)ret[0];
                val = (int)s;
            }
            else
            {
                UInt32 v;
                UInt32 u32 = (UInt32)ret[1];
                v = u32 << 16;
                v |= ret[0];

                val = (int)v;
            }

            numericUpDownPdoValue.Value = val;
        }

        private void buttonPdoWrite_Click(object sender, EventArgs e)
        {
            UInt32 Uidx = (UInt32)numericUpDownPdoNo.Value;
            UInt32 Gidx = (UInt32)numericUpDownPdoG.Value;

            UInt32 len = 0;
            UInt16[] ret = new UInt16[2];

            int val;
            val = (int)numericUpDownPdoValue.Value;
            if (0 == comboBoxPdoLen.SelectedIndex)
            {
                UInt32 u32 = (UInt32)val;
                ret[0] = (UInt16)(u32 & 0xFF);
                len = 1;
            }
            else if (1 == comboBoxPdoLen.SelectedIndex)
            {
                UInt32 u32 = (UInt32)val;
                ret[0] = (UInt16)(u32 & 0xFFFF);
                len = 1;
            }
            else
            {
                UInt32 u32 = (UInt32)val;
                ret[0] = (UInt16)(u32 & 0xFFFF);
                ret[1] = (UInt16)((u32 >> 16) & 0xFFFF);
                len = 2;
            }

            RetCode RET = ProCon.YKM_WritePDO(Uidx, Gidx, ret, len);
        }

        UInt32 sdoIndex = 0;
        private void buttonSdoRead_Click(object sender, EventArgs e)
        {
            UInt32 Uidx = (UInt32)numericUpDownSdoNo.Value;
            UInt32 mainIdx = (UInt32)numericUpDownSdoMain.Value;
            UInt32 subIdx = (UInt32)numericUpDownSdoSub.Value;

            uint bitNum;
            if (0 == comboBoxSdo.SelectedIndex)
                bitNum = 1;
            else if (1 == comboBoxSdo.SelectedIndex)
                bitNum = 2;
            else
                bitNum = 4;

            RetCode RET = ProCon.YKM_ReadSDOCmd(Uidx, mainIdx, subIdx, bitNum, out sdoIndex);
            if (RET != RetCode.RET_OK)
            {
                MessageBox.Show(RET.ToString());
            }

        }


        private void buttonSdoWrite_Click(object sender, EventArgs e)
        {
            UInt32 Uidx = (UInt32)numericUpDownSdoNo.Value;
            UInt32 mainIdx = (UInt32)numericUpDownSdoMain.Value;
            UInt32 subIdx = (UInt32)numericUpDownSdoSub.Value;
            ushort[] ret = new ushort[2];

            uint bitNum;
            uint i32 = (uint)numericUpDownSdoValue.Value;
            UInt32 val = (UInt32)i32;
            if (0 == comboBoxSdo.SelectedIndex)
            {
                UInt32 u32 = (UInt32)val;
                ret[0] = (UInt16)(u32 & 0xFF);
                bitNum = 1;
            }
            else if (1 == comboBoxSdo.SelectedIndex)
            {
                UInt32 u32 = (UInt32)val;
                ret[0] = (UInt16)(u32 & 0xFFFF);
                bitNum = 2;
            }
            else
            {
                bitNum = 4;
            }

            uint sdoindex_w;
            RetCode RET = ProCon.YKM_WriteSDOCmd(Uidx, mainIdx, subIdx, bitNum, val, out sdoindex_w);
        }
    
    }
}
