﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using YKCat2;

namespace DigitalIO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        UInt32 axis_size;

        private void buttonLoad_Click(object sender, EventArgs e)
        {
            RetCode result;
            //初始化函数，所有函数使用前必须要先初始化一次
            result = ProCon.YKM_LoadLib();
            if (result != RetCode.RET_OK)
            {
                MessageBox.Show("加载出错" + result.ToString());
                return;
            }

            buttonLoad.Enabled = false;
            buttonLoad.BackColor = Color.Green;

            //或者总线配置信息
            YKM_SysConfig config = new YKM_SysConfig();
            ProCon.YKM_GetSysConfig(out config);
            axis_size = config.config_axis_num;

            comboBoxAxisSel.Items.Clear();
            for (int idx = 0; idx < axis_size; idx++)
            {
                comboBoxAxisSel.Items.Add(idx.ToString());

                //设置当量
                ProCon.YKM_SetCommandEquiv((uint)idx, 1, 1000);
                ProCon.YKM_SetFeedbackEquiv((uint)idx, 1, 1000);
            }
            comboBoxAxisSel.SelectedIndex = 0;

            timer1.Enabled = true;
        }
        void currentPos()
        {
            UInt32 axis = 0;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;
            double pos;
            ProCon.YKM_ReadActualPosition(axis, out pos);
            current.Text = pos.ToString();

            if (probeSts)
            {
                uint sta;
                double probePos;
                ProCon.YKM_GetProbeStatus(axis, out sta, out probePos);
                if (sta == 1)
                {
                    probe_pos.Text = probePos.ToString();
                    probeSts = false;
                }
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            currentPos();
            sys_();
        }

        private void buttonAxisAbs_Click(object sender, EventArgs e)
        {
            UInt32 axis = 0;
            YKM_MoveAbsoluteConfig axis_abs = new YKM_MoveAbsoluteConfig();
            
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;

            //判断轴是否在忙中，忙的时候不可以调用别的运动指令
            YKM_AxisStatus sta;
            ProCon.YKM_ReadAxisInfo(axis, out sta);
            if (0 != sta.Active)
                return;

            axis_abs.position =(double)pos.Value;
            axis_abs.acceleration = (double)acc.Value;
            axis_abs.decelerateion = (double)acc.Value * 10;
            axis_abs.jerk = 10000;
            axis_abs.velocity = (double)val.Value;

            RetCode ret = ProCon.YKM_MoveAbsolute(axis, axis_abs);
            if (ret != RetCode.RET_OK)
            {
                MessageBox.Show("出错" + ret.ToString());
            }
        }

        private void butt_stop_Click(object sender, EventArgs e)
        {
            UInt32 axis = 0;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;
            ProCon.YKM_StopAxis(axis, 0);

        }

        void sys_()
        {
            YKM_BusInfo busInfo_;
            ProCon.YKM_GetBusInfo(out busInfo_);
            if (0 != busInfo_.running)
                labelBusSts.Text = "运动中";
            else
                labelBusSts.Text = "正在初始化";

        }

        bool probeSts = false;
        private void buttonAxisProbe_Click(object sender, EventArgs e)
        {
            UInt32 axis = 0;
            if (!UInt32.TryParse(comboBoxAxisSel.Text, out axis))
                return;

            RetCode RET = ProCon.YKM_StartProbe(axis);

            probeSts = true;
        }
    }
}
