﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using YKCat2;

namespace DigitalIO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            styleOn = new System.Windows.Forms.DataGridViewCellStyle();
            styleOff = new System.Windows.Forms.DataGridViewCellStyle();
            styleOn.BackColor = System.Drawing.Color.Blue;
            styleOff.BackColor = System.Drawing.Color.White;

            comboBoxEncSel.SelectedIndex = 0;
            limitSelect.SelectedIndex = 0;
            comboBoxAPay.SelectedIndex = 0;
            comboBoxBPay.SelectedIndex = 0;
            comboBoxCMPSel.SelectedIndex = 0;
            comboBoxCMPMode.SelectedIndex = 0;
            comboBoxCMP2D.SelectedIndex = 0;
            comboBoxCapSel.SelectedIndex = 0;
            comboBoxCapType.SelectedIndex = 0;
            comboBoxCapEdge.SelectedIndex = 0;

        }

        UInt32 axis_size;

        private void buttonLoad_Click(object sender, EventArgs e)
        {
            RetCode result;
            //初始化函数，所有函数使用前必须要先初始化一次
            result = ProCon.YKM_LoadLib();
            if (result != RetCode.RET_OK)
            {
                MessageBox.Show("加载出错" + result.ToString());
                return;
            }

            buttonLoad.Enabled = false;
            buttonLoad.BackColor = Color.Green;

            //或者总线配置信息
            YKM_SysConfig config = new YKM_SysConfig();
            ProCon.YKM_GetSysConfig(out config);
            axis_size = config.config_axis_num;


            timer1.Enabled = true;
        }


        private void timer1_Tick(object sender, EventArgs e)
        {
            sys_();
            getEncPos();
            getCapVlaue();
        }
        public void getCapVlaue()
        {
            uint CapSel = (uint)comboBoxCapSel.SelectedIndex;
            uint status = 0;
            ProCon.YKM_GetCaptureStatusPCI(0, CapSel, out status);
            if (status != 0)
            {
                int value = 0;
                ProCon.YKM_GetCaptureValuePCI(0, CapSel, out value);
                CapValue.Items.Insert(0, CapSel.ToString() + ":" + value);
            }
        }
        public void  getEncPos()
        {
            int channle = comboBoxEncSel.SelectedIndex;
            int pos;
            ProCon.YKM_GetEncoderValuePCI(0, (uint)channle, out pos);
            encPos.Value = pos;
        }
        System.Windows.Forms.DataGridViewCellStyle styleOn, styleOff;


        private void setCon_Click_1(object sender, EventArgs e)
        {
            int channle = comboBoxEncSel.SelectedIndex;
            YKM_EncoderConfig EncoderConfig = new YKM_EncoderConfig();
            EncoderConfig.mode = (YKM_ENCODER_MODE)limitSelect.SelectedIndex;
            EncoderConfig.polarityA = (uint)comboBoxAPay.SelectedIndex;
            EncoderConfig.polarityB = (uint)comboBoxBPay.SelectedIndex;
            ProCon.YKM_SetEncoderConfigPCI(0, (uint)channle, EncoderConfig);
            ProCon.YKM_StartEncoderPCI(0, (uint)channle);
        }

        private void btn_encZero_Click(object sender, EventArgs e)
        {
            int channle = comboBoxEncSel.SelectedIndex;
            ProCon.YKM_SetEncoderValuePCI(0, (uint)channle, 0);
        }

        private void getCon_Click_1(object sender, EventArgs e)
        {
            int channle = comboBoxEncSel.SelectedIndex;
            YKM_EncoderConfig EncoderConfig = new YKM_EncoderConfig();
            ProCon.YKM_GetEncoderConfigPCI(0, (uint)channle, out EncoderConfig);
            limitSelect.SelectedIndex = (int)EncoderConfig.mode;
            comboBoxAPay.SelectedIndex = (int)EncoderConfig.polarityA;
            comboBoxBPay.SelectedIndex = (int)EncoderConfig.polarityB;
        }

        private void btn_stopEnc_Click(object sender, EventArgs e)
        {
            int channle = comboBoxEncSel.SelectedIndex;
            ProCon.YKM_StopEncoderPCI(0, (uint)channle);
        }

        private void btnWriteCMP_Click(object sender, EventArgs e)
        {
          
            uint channle = (uint)comboBoxCMPSel.SelectedIndex;
            YKM_CompareItemData CompareItemData = new YKM_CompareItemData();
            CompareItemData.value1 = (int)numericUpDownvalue1.Value;
            CompareItemData.value2 = (int)numericUpDownvalue2.Value;
            CompareItemData.threshold = (uint)numericUpDownthreshold.Value;
            

            CompareItemData.out_bit0 = (uint)out_bit1_CMP.Value;
            CompareItemData.out_bit1 = (uint)out_bit2_CMP.Value;
            CompareItemData.out_bit2 = (uint)out_bit3_CMP.Value;
            CompareItemData.out_bit3 = (uint)out_bit4_CMP.Value;

            ProCon.YKM_SetCompareValuePCI(0, channle, CompareItemData);
        }

        private void btnStartCMP_Click(object sender, EventArgs e)
        {
            uint channle = (uint)comboBoxCMPSel.SelectedIndex;
            ProCon.YKM_StartComparePCI(0, channle);
           
        }

        private void btnStopCMP_Click(object sender, EventArgs e)
        {
            uint channle = (uint)comboBoxCMPSel.SelectedIndex;
            ProCon.YKM_StopComparePCI(0, channle);
          
        }

        private void btnReadCfgCMP_Click(object sender, EventArgs e)
        {
            uint channle = (uint)comboBoxCMPSel.SelectedIndex;
            YKM_CompareConfig CompareConfig = new YKM_CompareConfig();
            ProCon.YKM_GetCompareConfigPCI(0, channle, out CompareConfig);
            comboBoxCMP2D.SelectedIndex = (int)CompareConfig.enable_2d;
            comboBoxCMPMode.SelectedIndex = (int)CompareConfig.mode;
            numericUpDownKeepTime.Value = (int)CompareConfig.keep_time;
            numericUpDownSpacing1.Value = (int)CompareConfig.spacing1;
            numericUpDownSpacing2.Value = (int)CompareConfig.spacing2;
            LineModeNunber.Value = CompareConfig.number;

            if (CompareConfig.ena_bit0 == 1)
                ena_bit0.Checked = true;
            else
                ena_bit0.Checked = false;
            if (CompareConfig.ena_bit1 == 1)
                ena_bit1.Checked = true;
            else
                ena_bit1.Checked = false;
            if (CompareConfig.ena_bit2 == 1)
                ena_bit2.Checked = true;
            else
                ena_bit2.Checked = false;
            if (CompareConfig.ena_bit3 == 1)
                ena_bit3.Checked = true;
            else
                ena_bit3.Checked = false;
        }

        private void btnWriteCfgCMP_Click(object sender, EventArgs e)
        {
            uint channle = (uint)comboBoxCMPSel.SelectedIndex;
            YKM_CompareConfig CompareConfig = new YKM_CompareConfig();

            uint a, b, c, d;
            a = b = c = d = 0;
            if (ena_bit0.Checked)
                a = 1;
            CompareConfig.ena_bit0 = (uint)a;
            if (ena_bit1.Checked)
                b = 1;
            CompareConfig.ena_bit1 = (uint)b;
            if (ena_bit2.Checked)
                c = 1;
            CompareConfig.ena_bit2 = (uint)c;
            if (ena_bit3.Checked)
                d = 1;
            CompareConfig.ena_bit3 = (uint)d;

            CompareConfig.enable_2d = (uint)comboBoxCMP2D.SelectedIndex;
            CompareConfig.mode = (YKM_COMPARE_MODE)comboBoxCMPMode.SelectedIndex;
            CompareConfig.keep_time = (uint)numericUpDownKeepTime.Value;
            CompareConfig.spacing1 = (int)numericUpDownSpacing1.Value;
            CompareConfig.spacing2 = (int)numericUpDownSpacing2.Value;
            CompareConfig.number = (uint)LineModeNunber.Value;
            ProCon.YKM_SetCompareConfigPCI(0, channle, CompareConfig);
        }

        private void btnReadCapCfg_Click(object sender, EventArgs e)
        {
            uint  CapSel = (uint)comboBoxCapSel.SelectedIndex;
            YKM_CaptureConfig CaptureConfig = new YKM_CaptureConfig();
            ProCon.YKM_GetCaptureConfigPCI(0, CapSel, out CaptureConfig);
            comboBoxCapEdge.SelectedIndex = (int)CaptureConfig.edge;
            comboBoxCapType.SelectedIndex = (int)CaptureConfig.source_type;
        
        }

        private void btnWriteCapCfg_Click(object sender, EventArgs e)
        {
            uint CapSel = (uint)comboBoxCapSel.SelectedIndex;
            YKM_CaptureConfig CaptureConfig = new YKM_CaptureConfig();
            CaptureConfig.edge = (uint)comboBoxCapEdge.SelectedIndex;
            CaptureConfig.source_type = (uint)comboBoxCapType.SelectedIndex;
            ProCon.YKM_SetCaptureConfigPCI(0, CapSel, CaptureConfig);
        }

        private void btnStartCap_Click(object sender, EventArgs e)
        {
            uint CapSel = (uint)comboBoxCapSel.SelectedIndex;
            
            ProCon.YKM_StartCapturePCI(0, CapSel);
        }

        private void btnStopCap_Click(object sender, EventArgs e)
        {
            uint CapSel = (uint)comboBoxCapSel.SelectedIndex;
            ProCon.YKM_StopCapturePCI(0, CapSel);
        }

        private void CapValue_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            CapValue.Items.Clear();
        }

        void sys_()
        {
            YKM_BusInfo busInfo_;
            ProCon.YKM_GetBusInfo(out busInfo_);
            if (0 != busInfo_.running)
                labelBusSts.Text = "运动中";
            else
                labelBusSts.Text = "正在初始化";

        }
        
    }
}
