﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using YKCat2;

namespace DigitalIO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            styleOn = new System.Windows.Forms.DataGridViewCellStyle();
            styleOff = new System.Windows.Forms.DataGridViewCellStyle();
            styleOn.BackColor = System.Drawing.Color.Blue;
            styleOff.BackColor = System.Drawing.Color.White;
            CarAxisMode.SelectedIndex = 0;

            dataGridView2.RowCount = 8;
        }

        UInt32 axis_num = 0;

        private void buttonLoad_Click(object sender, EventArgs e)
        {
            RetCode result;
            //初始化函数，所有函数使用前必须要先初始化一次
            result = ProCon.YKM_LoadLib();
            if (result != RetCode.RET_OK)
            {
                MessageBox.Show("加载出错" + result.ToString());
                return;
            }

            cfg();

            buttonLoad.Enabled = false;
            buttonLoad.BackColor = Color.Green;           
        }

        public void cfg()
        {
            UInt32 num;
            YKM_CardConfigPCI CardConfigPCI = new YKM_CardConfigPCI();
            ProCon.YKM_GetCardNumPCI(out num);
            sysConfig.Items.Add("PCI数量：" + num.ToString());
            ProCon.YKM_GetCardConfigPCI(0, out CardConfigPCI);
            sysConfig.Items.Add("PCI类型：" + CardConfigPCI.type.ToString());
            sysConfig.Items.Add("PCI硬件版本：" + CardConfigPCI.hardware_ver.ToString());
            sysConfig.Items.Add("PCI固件版本：" + CardConfigPCI.firmware_ver.ToString());
            sysConfig.Items.Add("PCI数字输入数量,bit单位：" + CardConfigPCI.dinput_num.ToString());
            sysConfig.Items.Add("PCI数字输出数量,bit单位：" + CardConfigPCI.doutput_num.ToString());
            sysConfig.Items.Add("PCI轴数量：" + CardConfigPCI.axis_num.ToString());
            sysConfig.Items.Add("PCI编码器数量：" + CardConfigPCI.encode_num.ToString());
            sysConfig.Items.Add("PCI位置比较器数量：" + CardConfigPCI.compare_num.ToString());
            sysConfig.Items.Add("PCI位置捕获器数量：" + CardConfigPCI.capture_num.ToString());

            //或者配置信息
            YKM_SysConfig config = new YKM_SysConfig();
            ProCon.YKM_GetSysConfig(out config);
            axis_num = config.config_axis_num;

            comboBoxAxisSel.Items.Clear();
            for (int idx = 0; idx < axis_num; idx++)
            {
                comboBoxAxisSel.Items.Add(idx.ToString());
            }
            if (axis_num > 0)
                comboBoxAxisSel.SelectedIndex = 0;

            int count = (int)4;
            if (count > dataGridView2.RowCount)
            {
                count = dataGridView2.RowCount;
            }         

            timer1.Enabled = true;
        }

        public void axis_config()
        {
            uint axis = (uint)comboBoxAxisSel.SelectedIndex;
            YKM_AxisStausPCI AxisStausPCI = new YKM_AxisStausPCI();
            ProCon.YKM_GetAxisStatusPCI(0, axis, out AxisStausPCI);
            CarAxisMode.SelectedIndex = (int)AxisStausPCI.mode;
            PulseNumber.Value = AxisStausPCI.pls_pin;
            DirNumber.Value = AxisStausPCI.dir_pin;
            DutyNumber.Value = AxisStausPCI.duty;
            LimitNumberP.Value = AxisStausPCI.switchLimitP;
            LimitNumberN.Value = AxisStausPCI.switchLimitN;
            HomeNumbwe.Value = AxisStausPCI.switchHome;
            ReadyNumber.Value = AxisStausPCI.servoReady;
            ErrorNumber.Value = AxisStausPCI.servoWarn;
            InpNumber.Value = AxisStausPCI.servoInp;
            EnableNumber.Value = AxisStausPCI.servoEnable;
            ResetNumber.Value = AxisStausPCI.servoReset;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            sysStatus();
            axis_config();
            text();
        }

        System.Windows.Forms.DataGridViewCellStyle styleOn, styleOff;

        private void btn_setZero_Click(object sender, EventArgs e)
        {
            for (uint row = 0; row < 64; row++)
            {
                ProCon.YKM_SetUpEdgeNumPCI(0, row, 0);
            }
        }

        void text()
        {
            uint laiyu = (uint)type_select.SelectedIndex;
            if (laiyu == 0)
            {
                bytewei.Text = "不生效";
                BITwei.Text = "不生效";
            }
            else if (laiyu == 1)
            {
                bytewei.Text = "60FD的bit位";
                BITwei.Text = "不生效";
            }
            else if (laiyu == 2)
            {
                bytewei.Text = "全局IO的byte";
                BITwei.Text = "全局IO的bit";
            }
            else if (laiyu == 3)
            {
                bytewei.Text = "专用IO的byte";
                BITwei.Text = "专用IO的bit";
            }

        }

        private void getCon_Click_1(object sender, EventArgs e)
        {
            UInt32 axis = 0;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;
            uint selecte = (uint)function_select.SelectedIndex;
            YKM_SwitchConfig SwitchConfig = new YKM_SwitchConfig();
            YKM_ProbeConfig ProbeConfig = new YKM_ProbeConfig();

            if (selecte == 0)
                ProCon.YKM_GetSwitchPositivePCI(0, axis, out SwitchConfig);
            else if (selecte == 1)
                ProCon.YKM_GetSwitchNegativePCI(0, axis, out SwitchConfig);
            else if (selecte == 2)
                ProCon.YKM_GetSwitchHomePCI(0, axis, out SwitchConfig);
            else if (selecte == 3)
                ProCon.YKM_GetSwitchDrvReadyPCI(0, axis, out SwitchConfig);
            else if (selecte == 4)
                ProCon.YKM_GetSwitchDrvWarnPCI(0, axis, out SwitchConfig);
            else if (selecte == 5)
                ProCon.YKM_GetSwitchDrvInpPCI(0, axis, out SwitchConfig);
            else if (selecte == 6)
                ProCon.YKM_GetSwitchDrvEnablePCI(0, axis, out SwitchConfig);
            else if (selecte == 7)
                ProCon.YKM_GetSwitchDrvResetPCI(0, axis, out SwitchConfig);
            else if (selecte == 8)
                ProCon.YKM_GetSwitchProbePCI(axis, 0, out ProbeConfig);
            type_select.SelectedIndex = (int)SwitchConfig.type;
            zuxuanze.Value =SwitchConfig.byteOffset;
            bitxuanze.Value =SwitchConfig.bitOffset;

            if (selecte == 8)
            {
                type_select.SelectedIndex = (int)ProbeConfig.type;
                zuxuanze.Value = ProbeConfig.byteOffset;
                bitxuanze.Value = ProbeConfig.bitOffset;
                probeEdge.SelectedIndex = (int)ProbeConfig.edge;
            }
            if (SwitchConfig.inv == 0)
                xinhaoqufan.Checked = (bool)false;
            else
                xinhaoqufan.Checked = (bool)true;
        }

        private void setCon_Click_1(object sender, EventArgs e)
        {
            UInt32 axis = 0;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;

            YKM_SwitchConfig SwitchConfig = new YKM_SwitchConfig();
            YKM_ProbeConfig ProbeConfig = new YKM_ProbeConfig();

            uint selecte = (uint)function_select.SelectedIndex;
            SwitchConfig.type = (YKM_SwitchType)type_select.SelectedIndex;
            SwitchConfig.byteOffset = (uint)zuxuanze.Value;
            SwitchConfig.bitOffset = (uint)bitxuanze.Value;

            if (SwitchConfig.type == YKM_SwitchType.YKM_Switch_COE_REG)
            {
                SwitchConfig.type = YKM_SwitchType.YKM_Switch_NONE;
            }

            if ((bool)xinhaoqufan.Checked)
                SwitchConfig.inv = 1;
            else
                SwitchConfig.inv = 0;

            ProbeConfig.type = (YKM_SwitchType)type_select.SelectedIndex;
            ProbeConfig.byteOffset = (uint)zuxuanze.Value;
            ProbeConfig.bitOffset = (uint)bitxuanze.Value;
            ProbeConfig.edge = (uint)probeEdge.SelectedIndex;

            RetCode a;
            if (selecte == 0)
                a = ProCon.YKM_SetSwitchPositivePCI(0, axis, SwitchConfig);
            else if (selecte == 1)
                a = ProCon.YKM_SetSwitchNegativePCI(0, axis, SwitchConfig);
            else if (selecte == 2)
                a = ProCon.YKM_SetSwitchHomePCI(0, axis, SwitchConfig);
            else if (selecte == 3)
                ProCon.YKM_SetSwitchDrvReadyPCI(0, axis, SwitchConfig);
            else if (selecte == 4)
                ProCon.YKM_SetSwitchDrvWarnPCI(0, axis, SwitchConfig);
            else if (selecte == 5)
                ProCon.YKM_SetSwitchDrvInpPCI(0, axis, SwitchConfig);
            else if (selecte == 6)
                ProCon.YKM_SetSwitchDrvEnablePCI(0, axis, SwitchConfig);
            else if (selecte == 7)
                ProCon.YKM_SetSwitchDrvResetPCI(0, axis, SwitchConfig);
            else if (selecte == 8)
                ProCon.YKM_SetSwitchProbePCI(0, axis, ProbeConfig);
        }

        void sysStatus()
        {
            YKM_BusInfo busInfo_;
            ProCon.YKM_GetBusInfo(out busInfo_);
            if (0 != busInfo_.running)
                labelBusSts.Text = "运动中";
            else
                labelBusSts.Text = "正在初始化";

            uint inVale = 0;
            uint count = (int)8, channel = 0 ;
            for (int row = 0; row < count; row++)
            {
                for (int bit = 0; bit < 8; bit++)
                {
                    ProCon.YKM_GetUpEdgeNumPCI((uint)0, channel++, out inVale);
                    dataGridView2[bit, row].Value = inVale.ToString();
                }
            }
        }
        
    }
}
