﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using YKCat2;

namespace DigitalIO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            label3.Text = "";
        }

        UInt32 axis_size;
        private void buttonLoad_Click(object sender, EventArgs e)
        {
            RetCode result;
            //初始化函数，所有函数使用前必须要先初始化一次
            result = ProCon.YKM_LoadLib();
            if (result != RetCode.RET_OK)
            {
                MessageBox.Show("加载出错" + result.ToString());
                return;
            }
            ProCon.YKM_SetLogLevel(2);
            buttonLoad.Enabled = false;
            buttonLoad.BackColor = Color.Green;

            //或者总线配置信息
            YKM_SysConfig config = new YKM_SysConfig();
            ProCon.YKM_GetSysConfig(out config);
            axis_size = config.config_axis_num;

            comboBoxAxisSel.Items.Clear();
            for (int idx = 0; idx < axis_size; idx++)
            {
                comboBoxAxisSel.Items.Add(idx.ToString());
            }
            comboBoxAxisSel.SelectedIndex = 0;
            timer1.Enabled = true;
        }

        void currentPos()
        {
            UInt32 axis = 0;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;
            double pos;
            ProCon.YKM_ReadActualPosition(axis, out pos);
            current.Text = pos.ToString();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            currentPos();
            sysStatus();
        }

        private void buttonAxisAbs_Click(object sender, EventArgs e)
        {
            UInt32 axis = 0;
            YKM_MoveVelocityConfig axis_v = new YKM_MoveVelocityConfig();
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;

            //判断轴是否在忙中，忙的时候不可以调用别的运动指令
            YKM_AxisStatus sta;
            ProCon.YKM_ReadAxisInfo(axis, out sta);
            if (0 != sta.Active)
                return;

            axis_v.direction = YKM_DIRECTION.YKM_DIRECTION_POSITIVE;
            axis_v.acceleration = (double)acc.Value;
            axis_v.decelerateion = (double)acc.Value;
            axis_v.jerk = (double)acc.Value * 10;
            axis_v.velocity = (double)val.Value;
            ProCon.YKM_MoveVelocity(axis, axis_v);
        }

        private void but_inc_Click(object sender, EventArgs e)
        {
            UInt32 axis = 0;
            YKM_MoveVelocityConfig axis_v = new YKM_MoveVelocityConfig() ;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;

            //判断轴是否在忙中，忙的时候不可以调用别的运动指令
            YKM_AxisStatus sta;
            ProCon.YKM_ReadAxisInfo(axis, out sta);
            if (0 != sta.Active)
                return;

            axis_v.direction = YKM_DIRECTION.YKM_DIRECTION_NEGATIVE;
            axis_v.acceleration = (double)acc.Value;
            axis_v.decelerateion = (double)acc.Value * 10;
            axis_v.jerk = 10000;
            axis_v.velocity = (double)val.Value;

            ProCon.YKM_MoveVelocity(axis, axis_v);
        }

        private void butt_stop_Click(object sender, EventArgs e)
        {
            UInt32 axis = 0;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;
            ProCon.YKM_StopAxis(axis, 0);
        }

        void sysStatus()
        {
            YKM_BusInfo busInfo_;
           RetCode ret= ProCon.YKM_GetBusInfo(out busInfo_);
            if (0 != busInfo_.running)
                labelBusSts.Text = "运动中";
            else
                labelBusSts.Text = "正在初始化";

            YKM_AxisStatus sta;
            UInt32 axis = 0;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;

            ProCon.YKM_ReadAxisInfo(axis, out sta);
            if (0 != sta.Active)
                label3.Text = "运动中";
            else
                label3.Text = "空闲";
        }
    }
}
