﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using YKCat2;

namespace DigitalIO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            styleOn = new System.Windows.Forms.DataGridViewCellStyle();
            styleOff = new System.Windows.Forms.DataGridViewCellStyle();
            styleOn.BackColor = System.Drawing.Color.Blue;
            styleOff.BackColor = System.Drawing.Color.White;
            dataGridViewInput.RowCount = (int)1;
            dataGridViewInput.Rows[0].HeaderCell.Value = "轴参数";
        }

        UInt32 axis_size;

        private void buttonLoad_Click(object sender, EventArgs e)
        {
            RetCode result;
            //初始化函数，所有函数使用前必须要先初始化一次
            result = ProCon.YKM_LoadLib();
            if (result != RetCode.RET_OK)
            {
                MessageBox.Show("加载出错" + result.ToString());
                return;
            }

            buttonLoad.Enabled = false;
            buttonLoad.BackColor = Color.Green;

            //或者总线配置信息
            YKM_SysConfig config = new YKM_SysConfig();
            ProCon.YKM_GetSysConfig(out config);
            axis_size = config.config_axis_num;

            comboBoxAxisSel.Items.Clear();
            for (int idx = 0; idx < axis_size; idx++)
            {
                comboBoxAxisSel.Items.Add(idx.ToString());

                //设置当量
                ProCon.YKM_SetCommandEquiv((uint)idx, 1, 1000);
                ProCon.YKM_SetFeedbackEquiv((uint)idx, 1, 1000);
            }
            comboBoxAxisSel.SelectedIndex = 0;

            timer1.Enabled = true;
        }
        void currentPos()
        {
            UInt32 axis = 0;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;
            double pos;
            ProCon.YKM_ReadActualPosition(axis, out pos);
            current.Text = pos.ToString();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            currentPos();
            axis_sta();
            sys_();
        }
        System.Windows.Forms.DataGridViewCellStyle styleOn, styleOff;
        void axis_sta()
        {
            UInt32 axis = 0;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;
            YKM_AxisStatus axisInfo;
            int offset = 0;
            ProCon.YKM_ReadAxisInfo(axis, out axisInfo);

            if (axisInfo.HomeSwitch == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (axisInfo.LimitSwitchPos== 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (axisInfo.LimitSwitchNeg== 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (axisInfo.LimitSoftPos == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (axisInfo.LimitSoftNeg == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (axisInfo.PowerOn == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (axisInfo.IsHomed == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (axisInfo.InVelocity == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (axisInfo.IsGroup == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (axisInfo.Active == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (axisInfo.Done == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (axisInfo.Warnning == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            dataGridViewInput[offset++, 0].Value = axisInfo.AxisWarnID;
            dataGridViewInput[offset++, 0].Value = axisInfo.PlannerErrorID;
            dataGridViewInput[offset++, 0].Value = axisInfo.ServoErrorID;

        }
        private void buttonAxisAbs_Click(object sender, EventArgs e)
        {
            UInt32 axis = 0;
            YKM_MoveAbsoluteConfig axis_abs;
            
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;

            //判断轴是否在忙中，忙的时候不可以调用别的运动指令
            YKM_AxisStatus sta;
            ProCon.YKM_ReadAxisInfo(axis, out sta);
            if (0 != sta.Active)
                return;

            init(axis);
            axis_abs.position =(double)pos.Value;
            axis_abs.acceleration = (double)acc.Value;
            axis_abs.decelerateion = (double)acc.Value * 10;
            axis_abs.jerk = 10000;
            axis_abs.velocity = (double)val.Value;
            axis_abs.res1 = 0;
            axis_abs.res2 = 0;
            axis_abs.res3 = 0;
            axis_abs.res4 = 0;

            RetCode ret = ProCon.YKM_MoveAbsolute(axis, axis_abs);
            if (ret != RetCode.RET_OK)
            {
                MessageBox.Show("出错" + ret.ToString());
            }
        }

        private void but_inc_Click(object sender, EventArgs e)
        {
            UInt32 axis = 0;
            YKM_MoveRelativeConfig axis_inc;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;

            //判断轴是否在忙中，忙的时候不可以调用别的运动指令
            YKM_AxisStatus sta;
            ProCon.YKM_ReadAxisInfo(axis, out sta);
            if (0 != sta.Active)
                return;

            init(axis);
            axis_inc.distance = (double)pos.Value;
            axis_inc.acceleration = (double)acc.Value;
            axis_inc.decelerateion = (double)acc.Value * 10;
            axis_inc.jerk = 10000;
            axis_inc.velocity = (double)val.Value;
            axis_inc.res1 = 0;
            axis_inc.res2 = 0;
            axis_inc.res3 = 0;
            axis_inc.res4 = 0;

            ProCon.YKM_MoveRelative(axis, axis_inc);
        }


        void init(uint axis)
        {
            YKM_AxisProfile axis_pro;
            axis_pro.inp = 10;
            axis_pro.max_velocity = 1000;
            axis_pro.start_velocity = 1;
            axis_pro.stop_dec_emg = 1000;
            axis_pro.stop_dec_jerk = 1000;
            axis_pro.stop_dec_smooth = 1000;
            axis_pro.follow = 0;

            axis_pro.res1 = 0;
            axis_pro.res10 = 0;
            axis_pro.res2 = 0;
            axis_pro.res3 = 0;
            axis_pro.res4 = 0;
            axis_pro.res5 = 0;
            axis_pro.res6 = 0;
            axis_pro.res7 = 0;
            axis_pro.res8 = 0;
            axis_pro.res9 = 0;
 

          RetCode ret =  ProCon.YKM_SetAxisProfile(axis, axis_pro);
            if (ret != RetCode.RET_OK)
            {
                MessageBox.Show("出错" + ret.ToString());
            }
        }
      
        private void butt_stop_Click(object sender, EventArgs e)
        {
            UInt32 axis = 0;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;
            ProCon.YKM_StopAxis(axis, 0);

        }

        void sys_()
        {
            YKM_BusInfo busInfo_;
            ProCon.YKM_GetBusInfo(out busInfo_);
            if (0 != busInfo_.running)
                labelBusSts.Text = "运动中";
            else
                labelBusSts.Text = "正在初始化";

            labelPayMin.Text = busInfo_.min_payload.ToString();
            labelPayMax.Text = busInfo_.max_payload.ToString();
            labelPayCur.Text = busInfo_.cur_payload.ToString();

            labelDCMin.Text = busInfo_.min_shift.ToString();
            labelDCMax.Text = busInfo_.max_shift.ToString();
            labelDCCur.Text = busInfo_.cur_shift.ToString();

            Byte[] buff = new byte[2048];
            UInt32 buffSize = 2048;
            UInt32 num;
            ProCon.YKM_GetSysWarn(buff, buffSize, out num);
            if (num > 0)
            {
                List<String> resu;     // = new List<String>;
                 resu =  ProCon.TransWarns(num, buff);
                for (int i = 0; i < resu.Count; i++)
                {
                    sysConfig.Items.Insert(0, resu[i]);
                }
            }

            ProCon.YKM_GetSysLog(buff, buffSize);
            string log = ProCon.TransLog(buff);
            if (log != "")
                list_sys_log.Items.Insert(0, log);        
        }

        private void list_sys_log_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            list_sys_log.Items.Clear();
        }

        private void sysConfig_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            sysConfig.Items.Clear();
        }

        private void buttonPayReset_Click(object sender, EventArgs e)
        {
            ProCon.YKM_ClearBusInfo();
        }

        private void buttonClearBus_Click(object sender, EventArgs e)
        {
            RetCode RET = ProCon.YKM_ClearBusWarn();
        }

        private void buttonRstBus_Click(object sender, EventArgs e)
        {
            RetCode ret = ProCon.YKM_ResetBus();
        }
    }
}
