﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using YKCat2;

namespace DigitalIO
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            styleOn = new System.Windows.Forms.DataGridViewCellStyle();
            styleOff = new System.Windows.Forms.DataGridViewCellStyle();
            styleOn.BackColor = System.Drawing.Color.Blue;
            styleOff.BackColor = System.Drawing.Color.White;
            dataGridViewInput.RowCount = (int)1;
            dataGridViewInput.Rows[0].HeaderCell.Value = "轴参数";
            xianweixuanze.SelectedIndex = 0;
            laiyuanxuanze.SelectedIndex = 0;
        }

        UInt32 axis_size;

        private void buttonLoad_Click(object sender, EventArgs e)
        {
            RetCode result;
            //初始化函数，所有函数使用前必须要先初始化一次
            result = ProCon.YKM_LoadLib();
            if (result != RetCode.RET_OK)
            {
                MessageBox.Show("加载出错" + result.ToString());
                return;
            }

            buttonLoad.Enabled = false;
            buttonLoad.BackColor = Color.Green;

            //或者总线配置信息
            YKM_SysConfig config = new YKM_SysConfig();
            ProCon.YKM_GetSysConfig(out config);
            axis_size = config.config_axis_num;

            comboBoxAxisSel.Items.Clear();
            for (int idx = 0; idx < axis_size; idx++)
            {
                comboBoxAxisSel.Items.Add(idx.ToString());
            }
            comboBoxAxisSel.SelectedIndex = 0;

            timer1.Enabled = true;
        }
        void currentPos()
        {
            UInt32 axis = 0;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;
            double pos;
            ProCon.YKM_ReadActualPosition(axis, out pos);
            current.Text = pos.ToString();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            currentPos();
            axis_sta();
            sys_();
            text();
        }

        void text()
        {
            uint laiyu = (uint)laiyuanxuanze.SelectedIndex;
            if(laiyu == 0)
            {
                bytewei.Text = "不生效";
                BITwei.Text = "不生效";
            }
            else if (laiyu == 1)
            {
                bytewei.Text = "60FD的bit位";
                BITwei.Text = "不生效";
            }
            else if (laiyu == 2)
            {
                bytewei.Text = "全局IO的byte";
                BITwei.Text = "全局IO的bit";
            }


        }
        System.Windows.Forms.DataGridViewCellStyle styleOn, styleOff;
        void axis_sta()
        {
            UInt32 axis = 0;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;
            YKM_AxisStatus axisInfo;
            int offset = 0;
            ProCon.YKM_ReadAxisInfo(axis, out axisInfo);

            if (axisInfo.HomeSwitch == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (axisInfo.LimitSwitchPos== 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (axisInfo.LimitSwitchNeg== 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (axisInfo.LimitSoftPos == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (axisInfo.LimitSoftNeg == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (axisInfo.PowerOn == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (axisInfo.IsHomed == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (axisInfo.InVelocity == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (axisInfo.IsGroup == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (axisInfo.Active == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (axisInfo.Done == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            if (axisInfo.Warnning == 0)
                dataGridViewInput[offset++, 0].Style = styleOff;
            else
                dataGridViewInput[offset++, 0].Style = styleOn;

            dataGridViewInput[offset++, 0].Value = axisInfo.AxisWarnID;
            dataGridViewInput[offset++, 0].Value = axisInfo.PlannerErrorID;
            dataGridViewInput[offset++, 0].Value = axisInfo.ServoErrorID;

        }
        private void buttonAxisAbs_Click(object sender, EventArgs e)
        {
            UInt32 axis = 0;
            YKM_MoveAbsoluteConfig axis_abs = new YKM_MoveAbsoluteConfig();
            
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;

            //判断轴是否在忙中，忙的时候不可以调用别的运动指令
            YKM_AxisStatus sta;
            ProCon.YKM_ReadAxisInfo(axis, out sta);
            if (0 != sta.Active)
                return;

            axis_abs.position =(double)pos.Value;
            axis_abs.acceleration = (double)acc.Value;
            axis_abs.decelerateion = (double)acc.Value * 10;
            axis_abs.jerk = 10000;
            axis_abs.velocity = (double)val.Value;

            RetCode ret = ProCon.YKM_MoveAbsolute(axis, axis_abs);
            if (ret != RetCode.RET_OK)
            {
                MessageBox.Show("出错" + ret.ToString());
            }
        }

        private void butt_stop_Click(object sender, EventArgs e)
        {
            UInt32 axis = 0;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;
            ProCon.YKM_StopAxis(axis, 0);

        }

        private void getCon_Click(object sender, EventArgs e)
        {
            UInt32 axis = 0;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;
            uint xianwie = (uint)xianweixuanze.SelectedIndex;
            YKM_SwitchConfig sw = new YKM_SwitchConfig();
            YKM_ProbeConfig pro = new YKM_ProbeConfig();

            if (xianwie == 0)
                ProCon.YKM_GetSwitchPositiveBus(axis, 0, out sw);
            else if (xianwie == 1)
                ProCon.YKM_GetSwitchNegativeBus(axis, 0, out sw);
            else if (xianwie == 2)
                ProCon.YKM_GetSwitchHomeBus(axis, 0, out sw);
            else if (xianwie == 3)
                ProCon.YKM_GetTouchProbeBus(axis, 0, out pro);

            laiyuanxuanze.SelectedIndex = (int)sw.type;
            zuxuanze.Value = sw.byteOffset;
            bitxuanze.Value = sw.bitOffset;

            if (sw.inv == 0)
                xinhaoqufan.Checked = (bool)false;
            else
                xinhaoqufan.Checked = (bool)true;

            if (xianwie == 3)
            {
                laiyuanxuanze.SelectedIndex = (int)pro.type;
                zuxuanze.Value = pro.byteOffset;
                bitxuanze.Value = pro.bitOffset;
                probeEdge.SelectedIndex = (int)pro.edge;
         
            }

        }

        private void setCon_Click(object sender, EventArgs e)
        {
            UInt32 axis = 0;
            axis = (UInt32)comboBoxAxisSel.SelectedIndex;
       
            YKM_SwitchConfig sw = new YKM_SwitchConfig();
            YKM_ProbeConfig pro = new YKM_ProbeConfig();

            uint xianwie = (uint)xianweixuanze.SelectedIndex;
            sw.type = (YKM_SwitchType)laiyuanxuanze.SelectedIndex;
            sw.byteOffset = (uint)zuxuanze.Value;
            sw.bitOffset = (uint)bitxuanze.Value;

            pro.type = (YKM_SwitchType)laiyuanxuanze.SelectedIndex;
            pro.byteOffset = (uint)zuxuanze.Value;
            pro.bitOffset = (uint)bitxuanze.Value;
            pro.edge = (uint)probeEdge.SelectedIndex;


            laiyuanxuanze.SelectedIndex = (int)pro.type;
            zuxuanze.Value = pro.byteOffset;
            bitxuanze.Value = pro.bitOffset;
            probeEdge.SelectedIndex = (int)pro.edge;

            if ((bool)xinhaoqufan.Checked)
                sw.inv = 1;
            else
                sw.inv = 0;

            RetCode a;
            if (xianwie == 0)
                a = ProCon.YKM_SetSwitchPositiveBus(axis, 0, sw);
            else if (xianwie == 1)
                a = ProCon.YKM_SetSwitchNegativeBus(axis, 0, sw);
            else if (xianwie == 2)
                a = ProCon.YKM_SetSwitchHomeBus(axis, 0, sw);
            else if (xianwie == 3)
                a = ProCon.YKM_SetTouchProbeBus(axis, 0, pro);
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            ProCon.YKM_UnloadLib();
        }

        void sys_()
        {
            YKM_BusInfo busInfo_;
            ProCon.YKM_GetBusInfo(out busInfo_);
            if (0 != busInfo_.running)
                labelBusSts.Text = "运动中";
            else
                labelBusSts.Text = "正在初始化";

        }
        
    }
}
