﻿using NoLib;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;

namespace notimeIn
{
    public class MemOper
    {
        /// <summary>
        ///  共享内存名称
        /// </summary>
        const string MEM_NAME = "memtick";
        /// <summary>
        /// 结构体指针
        /// </summary>
        unsafe public static MemConfig* ptr_config
        {
            get;
            private set;
        }
        /// <summary>
        /// 创建共享内存
        /// </summary>
        /// <returns></returns>
        unsafe public static NoCode CreateShareMemory()
        {
            int size = Marshal.SizeOf(new MemConfig());
            ulong addr = 0;
            NoCode code = NoSys.NOS_CreateShareMemory(MEM_NAME, (uint)size, out addr);
            ptr_config = (MemConfig*)addr;
            ptr_config->times = 0;
            return code;
        }

        /// <summary>
        /// 打开共享内存
        /// </summary>
        /// <returns></returns>
        unsafe public static NoCode OpenShareMemory()
        {
            ulong addr = 0;
            NoCode code = NoSys.NOS_OpenShareMemory(MEM_NAME, out addr);
            ptr_config = (MemConfig*)addr;
            return code;
        }
        ///<summary>
        /// 读取次数
        /// </summary>
        /// <returns></returns>
        unsafe public static int GetTimes()
        {
            return ptr_config->times;
        }
    }
    unsafe public struct MemConfig
    {
        /// <summary>
        /// 数次
        /// </summary>
        public int times;
    }

}
