from enum import Enum
import ctypes
from ctypes import *

# <summary>
# 函数返回值定义
# </summary>
class RetCode(Enum):
    RET_OK = 0
    RET_LOAD = 1

class YKM_MC_ERRER(Enum):
    MC_ERRER_OK = 0
    MC_ERRER_CH = 1    

class YKM_POINT3(Structure):
    _fields_ = [
        ('x', c_double),
        ('y', c_double),
        ('z', c_double),
        ]

class YKM_SwitchConfig(Structure):
    _fields_ = [
        ('type', c_uint
         ),
        ('byteOffset', c_int),
        ('bitOffset', c_int),
        ('inv', c_int),
        ('ress1', c_int),
        ('res2', c_int),
        ('res3', c_int),
     #   ('res4', c_int),
    ]


class YKM_BusInfo(Structure):
    _fields_ = [
        ('running', c_uint),
        ('min_payload', c_int),
        ('max_payload', c_int),
        ('cur_payload', c_int),
        ('max_shift', c_int),
        ('min_shift', c_int),
        ('cur_shift', c_int),
        ('debug1', c_int),
        ('res1', c_uint),
        ('res2', c_uint),
        ('res3', c_uint),
        ('res4', c_uint),
        ('res5', c_uint),
        ('res6', c_uint),
        ('res7', c_uint),
        ('res8', c_uint), 
        ('res9', c_uint),
        ('res10', c_uint),
        ('res11', c_uint),
        ('res12', c_uint),
        ('res13', c_uint),
        ('res14', c_uint),
        ('res15', c_uint),
        ('res16', c_uint),

    ]


class YKM_AxisStatus(Structure):
    _fields_ = [
        ('HomeSwitch', c_uint),
        ('LimitSwitchPos', c_int),
        ('LimitSwitchNeg', c_int),
        ('LimitSoftPos', c_int),
        ('LimitSoftNeg', c_int),
        ('PowerOn', c_int),
        ('IsHomed', c_int),
        ('InVelocity', c_int),
        ('IsGroup', c_uint),
        ('Acitve', c_uint),
        ('Done', c_uint),
        ('Warnning', c_uint),
        ('AxisWarnID', c_uint),
        ('PlannerErrorID', c_uint),
        ('ServoErrorID', c_uint),
        ('res1', c_uint),
        ('res2', c_uint),
        ('res3', c_uint),
        ('res4', c_uint),
        ('res5', c_uint),
        ('res6', c_uint),
        ('res7', c_uint),
        ('res8', c_uint), 
        ('res9', c_uint),
        ('res10', c_uint),
    ]

class YKM_AxisProfile(Structure):
    _fields_ = [
        ('start_velocity', c_double),
        ('max_velocity', c_double),
        ('stop_dec_emg', c_double),
        ('stop_dec_smooth', c_double),
        ('stop_dec_jerk', c_double),
        ('inp', c_double),
        ('follow', c_double),
        ('res1', c_uint),
        ('res2', c_uint),
        ('res3', c_uint),
        ('res4', c_uint),
        ('res5', c_uint),
        ('res6', c_uint),
        ('res7', c_uint),
        ('res8', c_uint), 
    ]

class YKM_MoveAbsoluteConfig(Structure):
    _fields_ = [
        ('position', c_double),
        ('velocity', c_double),
        ('acceleration', c_double),
        ('decelerateion', c_double),
        ('jerk', c_double),
        ('res1', c_uint),
        ('res2', c_uint),
        ('res3', c_uint),
        ('res4', c_uint),
    ]


class YKM_MoveRelativeConfig(Structure):
    _fields_ = [
        ('distance', c_double),
        ('velocity', c_double),
        ('acceleration', c_double),
        ('decelerateion', c_double),
        ('jerk', c_double),
        ('res1', c_uint),
        ('res2', c_uint),
        ('res3', c_uint),
        ('res4', c_uint),
    ]