﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NotimeIntegrationEG_Notime
{
    /// <summary>
    /// 运动控制抽象
    /// </summary>
    public interface IMotion
    {
        /// <summary>
        /// 加载控制器
        /// </summary>
        /// <returns></returns>
        bool Load();

        /// <summary>
        /// 卸载控制器
        /// </summary>
        /// <returns></returns>
        bool UnLoad();

        /// <summary>
        /// 绝对定位运动
        /// </summary>
        /// <param name="axisIndex"></param>
        /// <param name="fPos"></param>
        /// <param name="fVel"></param>
        /// <param name="fACC"></param>
        /// <param name="fJerk"></param>
        /// <returns></returns>
        bool AxisMoveAbs(uint nAxisIndex, double fPos,double fVel, double fACC, double fJerk);

        /// <summary>
        /// 回零运动
        /// </summary>
        /// <param name="nAxisIndex"></param>
        /// <param name="nMode"></param>
        /// <param name="fMoveMax"></param>
        /// <param name="fVelHigh"></param>
        /// <param name="fVelLow"></param>
        /// <param name="fACC"></param>
        /// <returns></returns>
        bool Home(uint nAxisIndex, uint nMode, double fMoveMax, double fVelHigh, double fVelLow, double fACC);

        /// <summary>
        /// 设置输出
        /// </summary>
        /// <param name="nByteIndex"></param>
        /// <param name="nBitIndex"></param>
        /// <param name="bStatus"></param>
        /// <returns></returns>
        bool SetOutput(uint nByteIndex,uint nBitIndex, bool bStatus);

        /// <summary>
        /// 读取输入
        /// </summary>
        /// <param name="nByteIndex"></param>
        /// <param name="nBitIndex"></param>
        /// <returns></returns>
        bool GetInput(uint nByteIndex, uint nBitIndex);

        /// <summary>
        /// 轴运动状态
        /// </summary>
        /// <param name="nAxisIndex"></param>
        /// <param name="bStatus"></param>
        /// <returns></returns>
        bool AxisDone(uint nAxisIndex);
    }


}
