﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using csLTDMC;

namespace NotimeIntegrationEG_Notime
{
    public class MotionLTDMC : IMotion
    {
        double s_CurrentPos = 0;
        public bool AxisDone(uint nAxisIndex)
        {
            return LTDMC.dmc_check_done(0, (ushort)nAxisIndex) == 0 ? false : true;
        }

        public bool AxisMoveAbs(uint nAxisIndex, double fPos, double fVel, double fACC, double fJerk)
        {
            double dTime = fVel / fACC;
            dTime = dTime < 0.001 ? 0.001 : dTime;
            LTDMC.dmc_set_profile_unit(0, (ushort)nAxisIndex, 0, fVel, fVel/ fACC, fVel / fACC, 0);
            LTDMC.dmc_set_s_profile(0, (ushort)nAxisIndex, 0, fVel / fACC);
            int ret = LTDMC.dmc_pmove_unit(0, (ushort)nAxisIndex, fPos - s_CurrentPos, 0);
            s_CurrentPos = fPos;
            return ret == 0 ? true : false;

        }

        public bool GetInput(uint nByteIndex, uint nBitIndex)
        {
            return LTDMC.dmc_read_inbit(0, (ushort)nBitIndex) == 0 ? true : false;
        }

        public bool Home(uint nAxisIndex, uint nMode, double fMoveMax, double fVelHigh, double fVelLow, double fACC)
        {
            LTDMC.dmc_set_home_pin_logic(0, (ushort)nAxisIndex, 0, 0);
            LTDMC.dmc_set_homemode(0, (ushort)nAxisIndex, 0, 0, (ushort)nMode, 0);
            LTDMC.dmc_set_profile_unit(0, (ushort)nAxisIndex, fVelLow, fVelHigh, 0.1, 0.1, fVelLow );
            LTDMC.dmc_home_move(0, (ushort)nAxisIndex);//执行回原点运动
            while(LTDMC.dmc_check_done(0,(ushort)nAxisIndex) == 0)
            {
                System.Threading.Thread.Sleep(1);
            }
            ushort state = 0;
            int ret = LTDMC.dmc_get_home_result(0,(ushort)nAxisIndex,ref state);
            return ret == 0 ? true : false; 
        }

        public bool Load()
        {
            int nRet = LTDMC.dmc_board_init();
            if (nRet > 0)
            {
                nRet = LTDMC.dmc_download_configfile(0, $"{Environment.CurrentDirectory}\\LTDMCCfg.ini");
            }
            return nRet > 0 ? true : false;
        }

        public bool SetOutput(uint nByteIndex, uint nBitIndex, bool bStatus)
        {

            return LTDMC.dmc_write_outbit(0, (ushort)nBitIndex, (ushort)(bStatus ? 0 : 1)) == 0 ? true : false;
        }

        public bool UnLoad()
        {
            return LTDMC.dmc_board_close() == 0 ? true : false;
        }
    }
}
