﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using YKCat2;

namespace NotimeIntegrationEG_Notime
{
    public class MotionYKCat2 : IMotion
    {
        public bool AxisMoveAbs(uint nAxisIndex, double fPos,double fVel, double fACC, double fJerk)
        {
            YKM_MoveAbsoluteConfig axis_abs = new YKM_MoveAbsoluteConfig();
            axis_abs.position = fPos;
            axis_abs.acceleration = fACC;
            axis_abs.jerk = fJerk;
            axis_abs.velocity = fVel;
            RetCode ret = ProCon.YKM_MoveAbsolute(nAxisIndex, axis_abs);
            return ret == RetCode.RET_OK ? true : false;
        }

        public bool AxisDone(uint nAxisIndex)
        {
            YKM_AxisStatus status;
            RetCode ret = ProCon.YKM_ReadAxisInfo(nAxisIndex, out status);
            if (0 == status.Active || 1 == status.Done)
                return true;
            else
                return false;
        }

        public bool GetInput(uint nByteIndex, uint nBitIndex)
        {
            uint value = 0;
            RetCode ret = ProCon.YKM_ReadDigitalInputBit(nByteIndex, nBitIndex, out value);
            return value == 0 ? false : true;
        }



        public bool Home(uint nAxisIndex, uint nMode,double fMoveMax,double fVelHigh,double fVelLow,double fACC)
        {
            YKM_HomeConfig HomeConfig = new YKM_HomeConfig();
            HomeConfig.acceleration = fACC;
            HomeConfig.mode = (YKM_HOME_MODE)nMode;
            HomeConfig.probelMove = fMoveMax;
            HomeConfig.switchMove = fMoveMax;
            HomeConfig.velHigh = fVelHigh;
            HomeConfig.velLow = fVelLow;

            return ProCon.YKM_StartHome(nAxisIndex, HomeConfig) == RetCode.RET_OK ? true : false;
        }

        public bool Load()
        {
            //ProCon.YKM_SetLogLevel(2);
            return ProCon.YKM_LoadLib() == RetCode.RET_OK ? true : false;
        }

        public bool SetOutput(uint nByteIndex, uint nBitIndex, bool bStatus)
        {

            return ProCon.YKM_WriteDigitalOutputBit(nByteIndex, nBitIndex, (uint)(bStatus ? 1 : 0)) == RetCode.RET_OK ? true:false ;
        }

        public bool UnLoad()
        {
            return ProCon.YKM_UnloadLib() == RetCode.RET_OK ? true : false;
        }
    }
}
