﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NoLib;
using System.Threading;

namespace NotimeIntegrationEG_Notime
{
    public class WorkDocFlow
    {
        static double _fVel = 100;
        static double _fAcc = 1000;
        static double _fJerk = 10000;

        uint _nAxisIndex = 0;

        static WorkDocFlow _instance = null;
        static object _lock = new object();
        public WorkDocFlow()
        {
            _instance = this;
        }

        /// <summary>
        /// 单例引用
        /// </summary>
        /// <returns></returns>
        public static WorkDocFlow Instance()
        {
            if (_instance == null)
            {
                lock (_lock)
                {
                    if (_instance == null)
                    {
                        new WorkDocFlow();
                    }

                }
            }
            return _instance;
        }

        /// <summary>
        /// 等待轴停止
        /// </summary>
        /// <param name="nAxisIndex"></param>
        void WaitAxisDone(uint nAxisIndex,uint nTimeOut)
        {
            uint nTime = 0;
            while(MemOper.GetStart())
            {
                Thread.Sleep(1);
                if (MotionManager.Instance.AxisDone(_nAxisIndex) || (nTime>nTimeOut))
                {
                    break;
                }
                nTime++;
            }
        }

        /// <summary>
        /// 初始化
        /// </summary>
        public bool Init()
        {
            MotionManager.Instance = new MotionYKCat2();
            if (MotionManager.Instance.Load())
            {
                if (MemOper.CreateShareMemory() == NoCode.RET_OK)
                {
                    Console.WriteLine("共享内存创建成功");
                    StartTaskFlow();
                    return true;
                }
                Console.WriteLine("CreateShareMemory失败");
            }
            Console.WriteLine("Load失败");
            return false;
        }

        Thread _threadFlow = null;
        /// <summary>
        /// 启动流程任务
        /// </summary>
        public void StartTaskFlow()
        {
            if (_threadFlow == null)
            {
                _threadFlow = new Thread(
                    () =>
                    {
                        while (!MemOper.GetExit())
                        {
                            if (MemOper.GetStart())
                            {
                                //Move->A
                                MotionManager.Instance.AxisMoveAbs(_nAxisIndex, MemOper.GetTargetPosA(), _fVel, _fAcc, _fJerk);

                                WaitAxisDone(_nAxisIndex, 5000);

                                //Move->B
                                MotionManager.Instance.AxisMoveAbs(_nAxisIndex, MemOper.GetTargetPosB(), _fVel, _fAcc, _fJerk);

                                WaitAxisDone(_nAxisIndex, 5000);
                            }
                            else
                                Thread.Sleep(1);
                        }
                        MotionManager.Instance.UnLoad();
                    }
                    );
                _threadFlow.Start();
            }
        }
    }
}
