﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using NotimeIntegrationEG_Notime;
using YKCat2;

namespace NotimeIntegrationEG_Win
{
    public partial class FrmMain : Form
    {
        public FrmMain()
        {
            InitializeComponent();
        }


        private void btn_Start_Click(object sender, EventArgs e)
        {
            UpdatePos();
            MemOper.Start();
        }

        private void btn_Exit_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btn_Stop_Click(object sender, EventArgs e)
        {
            MemOper.Stop();
        }

        private void FrmMain_FormClosing(object sender, FormClosingEventArgs e)
        {
            MemOper.Stop();
            MemOper.Exit();
        }

        private void FrmMain_Load(object sender, EventArgs e)
        {
            ProCon.YKM_LoadLib();
            timer1.Enabled = true;
        }

        private void btn_WinStart_Click(object sender, EventArgs e)
        {
            WorkDocW.Instance().RunInWin();
            btn_WinStart.BackColor = Color.Green;
        }

        private void btn_NotimeStart_Click(object sender, EventArgs e)
        {
            WorkDocW.Instance().RunInNotime();
            btn_NotimeStart.BackColor = Color.Green;
        }

        private void UpdatePos()
        {
            double dbPosA = (double)nud_PosA.Value;
            double dbPosB = (double)nud_PosB.Value;
            MemOper.SetTargetPosA(dbPosA);
            MemOper.SetTargetPosA(dbPosB);
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            uint axisIndex = 0;
            double dbPos = 0;
            ProCon.YKM_ReadActualPosition(axisIndex, out dbPos);
            nud_CurPos.Value = (decimal)dbPos;
        }
    }
}
