﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NotimeIntegrationEG_Notime;
using System.Threading.Tasks;
using System.Threading;
using YKCat2;
using System.Diagnostics;

namespace NotimeIntegrationEG_Win
{
    public delegate void DelegateShowMSG(string str);
    public class WorkDocW
    {
        bool _bExit = false;

        static WorkDocW _instance = null;
        static object _lock = new object();
        public WorkDocW()
        {
            _instance = this;
        }

        /// <summary>
        /// 单例引用
        /// </summary>
        /// <returns></returns>
        public static WorkDocW Instance()
        {
            if (_instance == null)
            {
                lock (_lock)
                {
                    if (_instance == null)
                    {
                        new WorkDocW();
                    }
                }
            }
            return _instance;
        }

        readonly string APP_NAME = "NotimeIntegrationEG_Notime.exe";
        /// <summary>
        /// windows下运行
        /// </summary>
        public void RunInWin()
        {
            var ret = WorkDocFlow.Instance().Init();
            if (!ret)
            {
                System.Windows.Forms.MessageBox.Show("Windows系统下启动失败");
                return;
            }

            System.Threading.Thread.Sleep(3000);

            NoLib.NoCode noCode = MemOper.OpenShareMemory();
            if (noCode != NoLib.NoCode.RET_OK)
            {
                System.Windows.Forms.MessageBox.Show("共享内存打开失败");
                return;
            }

            WorkDocFlow.Instance().StartTaskFlow();
        }

        /// <summary>
        /// 实时系统下运行
        /// </summary>
        public void RunInNotime()
        {
            RetCode ret = RetCode.RET_OK;
            ret = ProCon.YKM_LoadLib();
            if (ret != RetCode.RET_OK)
            {
                return;
            }
            string startName = $"{Environment.CurrentDirectory}\\{APP_NAME}";
            byte[] name = Encoding.UTF8.GetBytes(startName);
            ret = ProCon.YKM_LoadNotimeApp(name);
            if (ret != RetCode.RET_OK)
            {
                System.Windows.Forms.MessageBox.Show("实时系统下启动失败");
                return;
            }

            System.Threading.Thread.Sleep(3000);

            NoLib.NoCode noCode = MemOper.OpenShareMemory();
            if (noCode != NoLib.NoCode.RET_OK)
            {
                System.Windows.Forms.MessageBox.Show("共享内存打开失败");
                return;
            }
        }
    }
}
